rollout unnamedRollout "PMD Utility" width:180 height:630
(

	button btn1 "IMPORT" pos:[10,7] width:160 height:30
	groupBox grp1 "Import Options" pos:[10,144] width:160 height:205
	checkbox mshchk "Model" pos:[20,164] width:70 height:21 checked:true
	button btn2 "EXPORT" pos:[10,44] width:160 height:30
	checkbox morchk "Morphs" pos:[20,184] width:70 height:21 checked:true
	checkbox bonchk "Bones" pos:[20,204] width:70 height:21 checked:true
	checkbox sknchk "Weights" pos:[20,224] width:70 height:21 checked:true
	checkbox frmchk "Frames" pos:[100,184] width:65 height:21 enabled:false checked:false
	checkbox colchk "Collison" pos:[100,204] width:65 height:21 checked:true
	checkbox phychk "Physics" pos:[100,224] width:65 height:21 checked:true
	checkbox engchk "" pos:[20,244] width:17 height:21 checked:false
	editText edt1 "" pos:[18,301] width:135 height:20
	checkbox scalechk "Scale Fix" pos:[20,370] width:70 height:21 enabled:false checked:false
	radioButtons rdo1 "Language Conversion" pos:[36,248] width:85 height:46 enabled:false labels:#("From PMD", "From File") default:1
	button bwse "Browse" pos:[23,323] width:54 height:18
	button abtBttn "About" pos:[126,601] width:44 height:18
	checkbox ikschk "IK's" pos:[100,164] width:65 height:21 checked:true
	checkbox flpchk "Flip UVs" pos:[20,390] width:114 height:21 enabled:true checked:false
	groupBox grp6 "Animations" pos:[10,80] width:160 height:60
	button btn3 "Import" pos:[24,99] width:60 height:30
	button btn4 "Export" pos:[96,99] width:60 height:30
	button btnA "Hide Collision Model" pos:[30,485] width:123 height:19
	groupBox grp3 "QuickTools" pos:[10,461] width:160 height:137
	button btnD "UVs Discontinuities" pos:[30,525] width:123 height:19
	label lbl1 "v 0.6   (03.26.11)" pos:[13,604] width:103 height:14
	button btnB "Hide Bone Nubs" pos:[30,505] width:123 height:19
	button btnX "Tool Box" pos:[30,560] width:123 height:19
	checkbox nrmchk "Weld Normals" pos:[20,430] width:104 height:21 enabled:true checked:false
	checkbox chk15 "Rebuild UVs" pos:[20,410] width:122 height:21 enabled:false checked:false
	groupBox grp4 "Export Fixes" pos:[10,354] width:160 height:103
	spinner spn1 "" pos:[102,371] width:49 height:16 enabled:false range:[0,100,0] scale:1



fn ReadFixedString bstream fixedLen =(
local str = ""
for i = 1 to fixedLen do(
str0 = ReadByte bstream #unsigned
if str0==0x0A do str+="\r\n"
if str0!=0xFD AND str0!=0xFC do str+= bit.intAsChar str0)
str)

fn WriteFixedString fstream len str=(
getPos=ftell fstream
writestring fstream str
for x = 1 to len do writebyte fstream 0xFD
fseek fstream (getPos+len) #seek_set
)

-- on edt1 entered txt do( -- for scale thingy
-- if txt != "" do(
-- typedOffset=txt as float
-- if typedOffset<=0 do(
-- typedOffset=typedOffset*-1
-- 	)
-- local typedOffset
-- 	)
-- )


on btn1 pressed do( --PMD Import

fsource = GetOpenFileName \
caption:"PMD Importer" \
types: "Polygon Model Data(*.pmd)|*.PMD|All files (*.*)|*.*|"
if (fsource!=undefined) AND ((doesFileExist fsource)==true) then(
f = fopen fsource "rb"
fext=           getFilenameType fsource
fpath=          getFilenamePath fsource
fbatch=         getFiles (fpath+"*"+fext)
fname=  getFilenameFile fsource
fsize=          getFileSize fsource
st = timestamp() --get start time in milliseconds
clearlistener()
openLog (fpath+fname+"_log.txt") mode:"w" outputOnly:true
print (fname+fext+"\n"+localTime+"\n")
--===========================================================================
undo off(

fn ReadFixedString bstream fixedLen =
(
	local str = ""
	for i = 1 to fixedLen do
	(
		str0 = ReadByte bstream #unsigned
		if str0==0x0A do str+="\r\n"
		if str0!=0xFD AND str0!=0xFC do str+= bit.intAsChar str0
	)
	str
)
with redraw off (
	
	local modelscale=1
	local mshON=mshchk.checked
	local morON=morchk.checked
	local bonON=bonchk.checked
	local sknON=sknchk.checked
	local iksON=ikschk.checked
	local frmON=frmchk.checked
	local colON=colchk.checked
	local phyON=phychk.checked
	local texON=true
	local engON=engchk.checked -- BROKEN!
	local logON=false
	
	
fileName =ReadFixedString f 3
if fileName=="Pmd" do(
Face_array=#()
Vert_array=#()
UV_array=#()
Normal_array=#()
matIDArray=#()
morlist=#()
ikArray=#()
phyMesh=#()
phyNames=#()
phyIndex=#()
collisionObj=#()
ikLimits=#()
BNArr = #()
normalindex=#()
normalbuff=#()
Weight_array=#()
struct weight_data
(
   boneids,weights
)
-- Name and Dialog Section
-- ===========================================================================
Print ("Section 01: Name/Comments @ 0x"+((bit.intAsHex(ftell f))as string))	

fileVersion=readfloat f
mdllNameA=ReadFixedString f 20
commentsA=ReadFixedString f 256

-- Vertex Section
-- ===========================================================================
Print ("Section 02: Model Data @ 0x"+((bit.intAsHex(ftell f))as string))	


for x = 1 to (readlong f #unsigned) do(
vx=readfloat f*modelscale
vy=readfloat f*modelscale
vz=readfloat f*modelscale
nx=readfloat f
ny=readfloat f
nz=readfloat f
tu=readfloat f
tv=readfloat f*-1
b1=readshort f
b2=readshort f
if b1==-1 do b1=0
if b2==-1 do b2=0
bw=(readshort f as float)/100
append Vert_array[vx,vz,vy]
append Normal_array[nx,nz,ny]
append UV_array[tu,tv,0]


if b1==b2 do b2=1

w1=bw
w2=1.0-bw

w = (weight_data boneids:#() weights:#())
if(w1 !=0.0) do(
append w.boneids (b1 + 1)
append w.weights w1
)
if(w2 !=0.0) do(
append w.boneids (b2 + 1)
append w.weights w2
)    
append Weight_array w
)
for x = 1 to ((readlong f #unsigned)/3) do(
fa=readshort f #unsigned+1
fb=readshort f #unsigned+1
fc=readshort f #unsigned+1
append Face_array[fc,fb,fa]
)

--Material Section
-- ===========================================================================
Print ("Section 03: Materials @ 0x"+((bit.intAsHex(ftell f))as string))	
matCount=readlong f #unsigned
mm = MultiMaterial()
mm.numsubs=matCount

toonflags=#()	

for x = 1 to matCount do(
dr=(floor (readfloat f * 255)) as integer -- Diffuse Colour
dg=(floor (readfloat f * 255)) as integer
db=(floor (readfloat f * 255)) as integer
da=readfloat f * 100 as integer
gl=readfloat f as integer -- Spec Power/Level, maybe gloss???
sp=readfloat f --use red as spec power
sr=(floor (sp * 255)) as integer -- Spec Colour
sg=(floor (readfloat f * 255)) as integer
sb=(floor (readfloat f * 255)) as integer
ar=(floor (readfloat f * 255)) as integer -- Ambient Colour
ag=(floor (readfloat f * 255)) as integer
ab=(floor (readfloat f * 255)) as integer
toon=readbyte f+1 -- Falloff Texture Index
append toonflags toon
outline=readbyte f -- Toon Flag either 0 or 1, creates black outline??
apexes=readlong f -- faces with this material
append matIDArray apexes

texName=""
refName=""
for i = 1 to 20 do(
str0 = ReadByte f #unsigned
if str0==0x2A do refName=" "
if refName=="" then (if str0!=0xFD AND str0!=0xFC do texName+= bit.intAsChar str0)
else(
if refName==" *" do refName=""
if str0!=0xFD AND str0!=0xFC do refName+= bit.intAsChar str0
))
if (skipToString (texName as stringstream) ".spa")==ok \
OR (skipToString (texName as stringstream) ".sph")==ok do (
refName=texName
texName=""
)

mat=mm.materialList[x]
if x <=9 do mat.name = ("mat_00"+(x as string))
if x >=10 do mat.name = ("mat_0"+(x as string))
if x >=100 do mat.name = ("mat_"+(x as string))
mat.adLock = off
mat.adTextureLock = off
mat.Diffuse = color ar ag ab
mat.ambient = color dr dg db
mat.specularLevel = (floor (sp * 100)) as integer
mat.opacity = da
mat.Specular = color sr sg sb
mat.glossiness = gl
if outline==0 then (mat.twoSided = off) else (mat.twoSided = on)
if texName!="" do (
mm.materialList[x].diffuseMap = Bitmaptexture fileName:(fpath+texName)
mat.adTextureLock = on
mat.ambient = color 149.94 149.94 149.94
mat.selfIllumAmount = 100
showTextureMap mat true

)

asrc=2
if refName!="" do (
if texON==true do(
if doesFileExist (fpath+refName)==true do (
copyFile (fpath+refName) (fpath+(readChars (refName as stringstream) (refName.count-3))+"bmp")
))
if (skipToString (refName as stringstream) ".spa")==ok do asrc=1
refName=((readChars (refName as stringstream) (refName.count-3))+"bmp")
mat.reflectionMap = Bitmaptexture fileName:(fpath+refName)
mat.reflectionMap.alphaSource = asrc
))


--Bone Section
-- ===========================================================================
Print ("Section 04: Bones @ 0x"+((bit.intAsHex(ftell f))as string))

boneArray=#()
struct boneInfo (
bName,
bChild,
bParent,
boneX,
boneY,
boneZ,
boneIK,
bType	
)
for x = 1 to (readshort f #unsigned) do(
boneName=ReadFixedString f 20
parent=readshort f
child=readshort f
type=readbyte f -- ???
boneIK=readshort f
boneX=readfloat f*modelscale
boneY=readfloat f*modelscale
boneZ=readfloat f*modelscale
append boneArray(boneInfo bName:boneName bChild:child bParent:parent boneX:boneX boneY:boneZ boneZ:boneY boneIK:boneIK bType:type)
)


-- Inverse Kinematics Section
-- ===========================================================================
Print ("Section 05: IK Chains @ 0x"+((bit.intAsHex(ftell f))as string))	
for x = 1 to (readshort f #unsigned) do(
ikGoal=readshort f+1
endIK=readshort f+1
numIK=readbyte f -- number of bones in IK chain... not really important
ukn1=readshort f --loop count? " ????? "
ukn2=readfloat f -- rotation limit?
startIK=1
for y = 1 to numIK do( -- gives the bone IDs that are included in IK chain
linkIK=readshort f+1
startIK=linkIK
	)
append ikArray[startIK,endIK,ikGoal]
append ikLimits[ukn1,ukn2]
)

--Morph Section
-- ===========================================================================
Print ("Section 06: Morphs @ 0x"+((bit.intAsHex(ftell f))as string))	

morCount=readshort f #unsigned
morIndex=#()
morTypes=#()
morNameArray=#()
for y = 1 to morCount do(
morName=ReadFixedString f 20
append morNameArray morName
vertCount=readlong f #unsigned
morGrp=readbyte f

morArray=#()
for x = 1 to vertCount do(
idx=readlong f+1
vx=readfloat f*modelscale
vy=readfloat f*modelscale
vz=readfloat f*modelscale
if y!=1 then (append morArray[idx,vx,vy,vz]) else(
append morIndex idx
if mshON==false do append morArray[x,vx,vy,vz];morGrp=4
))
if morON==true do(
if mshON==true then(
msh = mesh vertices:Vert_array faces:#()
)else(
msh = mesh vertices:Vert_array faces:Face_array
)

msh.numTVerts = UV_array.count	
buildTVFaces msh
msh.name=morName
if mshON==true AND y!=1 do(
append morlist msh
append morTypes morGrp
)
for x = 1 to morArray.count do(
-- if y==2 do print  ((morIndex[(morArray[x][1] as integer)] as integer) as string)
vPos=getVert msh (morIndex[(morArray[x][1] as integer)] as integer)
vx=vPos.x + morArray[x][2]
vy=vPos.y + morArray[x][4]
vz=vPos.z + morArray[x][3]

setVert msh (morIndex[(morArray[x][1] as integer)] as integer) [vx,vy,vz]
)
update msh
)

) --end morph loop

-- Frame/Hierarchy Section (Groups Various bones, and other scene nodes)
-- ===========================================================================
Print ("Section 07: Frames @ 0x"+((bit.intAsHex(ftell f))as string))

ikNodeArray=#()
ikCateArray=#()
for x = 1 to readbyte f #unsigned do(
ukn=readshort f -- ?? Index of some sort?
)

frameCount=readbyte f #unsigned
for x = 1 to frameCount do( -- Category Names (can be custom made categories)
catName=ReadFixedString f 50
if frmON==true do(
dSize=modelscale*1
obj=Dummy name:catName \
boxsize:[dSize,dSize,dSize] \
isSelected:off
append ikNodeArray obj
))

for x = 1 to readlong f #unsigned do(
nodIndex=readshort f -- indexes the bones..
catIndex=readbyte f -- Index tells which category to put the node or bone under...
append ikCateArray[catIndex,nodIndex])


--English Name Section (Section Optional)
-- ===========================================================================
Print ("Section 08: English Names @ 0x"+((bit.intAsHex(ftell f))as string))
	

if (ftell f)!=fsize do( -- section is not required by MMD, so data may stop here...
engData=readbyte f -- english names, NOT REQUIRED
engBones=#()
engIKs=#()	
engMorphs=#()
for x = 1 to engData do(

mdllNameB=ReadFixedString f 20
commentsB=ReadFixedString f 256

Print ("Section 08b: Bone Names @ 0x"+((bit.intAsHex(ftell f))as string))
for x = 1 to boneArray.count do(
boneName=ReadFixedString f 20
append engBones boneName
)

Print ("Section 08c: Morph Names @ 0x"+((bit.intAsHex(ftell f))as string))
for x = 1 to morCount-1 do(
morName=ReadFixedString f 20
append engMorphs morName
)

Print ("Section 08d: IK Chain Names @ 0x"+((bit.intAsHex(ftell f))as string))
for x = 1 to frameCount do(
ikName=ReadFixedString f 50
append engIKs ikName
)
) --ends english names

Print ("Section 08e: Toon Names @ 0x"+((bit.intAsHex(ftell f))as string))
toonnames=#()
for x = 1 to 10 do(
toonName=ReadFixedString f 100
append toonnames toonName
)

for x = 1 to toonflags.count do(
if toonflags[x]>=1 do(
mm.materialList[x].refractionMap = Bitmaptexture fileName:(toonnames[(toonflags[x])])
mm.materialList[x].refractionMapEnable = off
))

)

-- Collision Model Section
-- ===========================================================================
Print ("Section 09: Collision Model @ 0x"+((bit.intAsHex(ftell f))as string))	

if (ftell f)!=fsize do( -- this section is new to PMD, MMD recently added physics support. 

-- deg=57.295782 -- A magical number that converts the float value into degrees....

mat = Standardmaterial ()
mat.name = "shape"
mat.Diffuse = color 150 255 0
mat.wire = on
	

for x = 1 to readlong f #unsigned do(
phyName=ReadFixedString f 20 --name of physics model
phyName="japSucks_";phyName+=(x as string)
append phyNames phyName
idx=readshort f+1 -- ?? bone index that object is attached to?
append phyIndex idx
grpArray=#()
	
curGrp=readbyte f -- flag for drop box, options range from 0x00 - 0xF0 (16)
GrpA=(0xFF-(readbyte f #unsigned)) -- flags for  1-8 tick boxes..? wtf calculation is wrong of this area ? groups
GrpB=(0xFF-(readbyte f #unsigned)) -- flags for 9-16 tick boxes..? wtf calculation is wrong of this area ? groups
	

while GrpA!=0 do(
grp=1
cnt=0
an=0
while an!=1 do(
an=(GrpA/grp)
grp=grp*2
cnt+=1
)
GrpA-=grp/2
append grpArray cnt
)
while GrpB!=0 do(
grp=1
cnt=0
an=0
while an!=1 do(
an=(GrpB/grp)
grp=grp*2
cnt+=1
)
GrpB-=grp/2
append grpArray (cnt+8)
)
pShape=undefined

phyShape=readbyte f -- PhyBox Shape (0)Sphere (1)Box (3)Capsule

-- PhyBox Info, Pos, Size, Rotation.. etc...
phyR=readfloat f*modelscale -- Raduis/Width
phyH=readfloat f*modelscale -- Height
phyS=readfloat f*modelscale -- Length
pmx=readfloat f*modelscale -- X position
pmy=readfloat f*modelscale -- Y position
pmz=readfloat f*modelscale -- Z position
prx=readfloat f -- X rotation
pry=readfloat f -- Y rotation
prz=readfloat f -- Z rotation
pMass=readfloat f -- Mass (Weight)
pMDecay=readfloat f -- Move Decay
pRDecay=readfloat f -- Rotation Decay
pGrav=readfloat f -- ?? bounce or gravity lol
pFric=readfloat f -- ?? Force or Friction lol

ukn=readbyte f -- Physics Type Flag: (0)Following Bone (1)Physics (3)Bone alignment ?? wtf is this

if colON==true do(
if phyShape==0x00 do(
pShape=Sphere radius:phyR \
name:phyName \
material:mat \
smooth:on \
segs:12 chop:0 \
slice:off \
sliceFrom:0 \
sliceTo:0 \
mapcoords:on \
recenter:off \
realWorldMapSize:on \
pos:[pmx,pmz,pmy] \
isSelected:on
obj=getCurrentSelection()
append phyMesh obj
$.wirecolor = color 100 100 150
$.renderable = off
rotate $ (angleaxis (radToDeg (prx*-1)) [1,0,0])
rotate $ (angleaxis (radToDeg (prz*-1)) [0,1,0])
rotate $ (angleaxis (radToDeg (pry*-1)) [0,0,1])

)

if phyShape==0x01 do(
pShape=Box \
name:phyName \
material:mat \
lengthsegs:1 \
widthsegs:1 \
heightsegs:1 \
length:(phyS*2) \
width:(phyR*2) \
height:(phyH*2) \
mapcoords:on \
realWorldMapSize:on \
pivot:[0,0,phyH] \
pos:[pmx,pmz,pmy] \
isSelected:on
obj=getCurrentSelection()
append phyMesh obj
$.wirecolor = color 200 255 150
$.renderable = off
rotate $ (angleaxis (radToDeg (prx*-1)) [1,0,0])
rotate $ (angleaxis (radToDeg (prz*-1)) [0,1,0])
rotate $ (angleaxis (radToDeg (pry*-1)) [0,0,1])
)

if phyShape==0x02 do(
pShape=Capsule radius:phyR \
name:phyName \
material:mat \
height:(phyH*1.3) \
heighttype:0 \
sides:8 \
heightsegs:1 \
smooth:on \
sliceon:off \
sliceFrom:0 \
sliceTo:0 \
mapcoords:on \
realWorldMapSize:on \
pivot:[0,0,(phyH/2)] \
pos:[pmx,pmz,pmy] \
isSelected:on
obj=getCurrentSelection()
append phyMesh obj
$.wirecolor = color 255 200 150
$.renderable = off
rotate $ (angleaxis (radToDeg (prx*-1)) [1,0,0])
rotate $ (angleaxis (radToDeg (prz*-1)) [0,1,0])
rotate $ (angleaxis (radToDeg (pry*-1)) [0,0,1])
-- transform:(matrix3 [1,0,0] [0,0,1] [0,-1,0] [0,0,0]) \
)
append collisionObj pShape
setUserPropBuffer $ ""
setUserProp obj "Type" ukn
setUserProp obj "Mass" pMass
setUserProp obj "Friction" pFric
setUserProp obj "Stiffness" pGrav
setUserProp obj "RotDecay" pRDecay
setUserProp obj "PosDecay" pMDecay
setUserProp obj "ActiveGroup" curGrp
colArray=#(false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false)

for x = 1 to grpArray.count do(
colArray[(grpArray[x])]=true)

for x = 1 to 16 do(
setUserProp obj ("EffectGroup"+(x as string)) (colArray[x])
)))


-- Physics Section
-- ===========================================================================
Print ("Section 10: Physics @ 0x"+((bit.intAsHex(ftell f))as string))	

jntArray=#()
jntNodes=#()
struct jointInfo (
jName,
jChild,
jParent,
jointX,
jointY,
jointZ,
jPos1X,
jPos2X,
jPos1Y,
jPos2Y,
jPos1Z,
jPos2Z,
jRot1X,
jRot2X,
jRot1Y,
jRot2Y,
jRot1Z,
jRot2Z,
sprPosX,
sprPosY,
sprPosZ,
sprRotX,
sprRotY,
sprRotZ
)	

for x = 1 to readlong f #unsigned do(
jntName=ReadFixedString f 20 --Joint name
append jntArray jntName
ph1=readlong f+1 -- Index to which Physics Box to Attach
ph2=readlong f+1 -- Second Index to a second Physics Box??

-- Joint Positions
jmx=readfloat f*modelscale -- X position
jmy=readfloat f*modelscale -- Y position
jmz=readfloat f*modelscale -- Z position

jrx=radToDeg (readfloat f) -- X rotation
jry=radToDeg (readfloat f) -- Y rotation
jrz=radToDeg (readfloat f) -- Z rotation

-- Joint Constraints.. (Move/Rotation Limits)
jPos1X=readfloat f -- X position (-)
jPos1Y=readfloat f -- Y position (-)
jPos1Z=readfloat f -- Z position (-)

jPos2X=readfloat f -- X position (+)
jPos2Y=readfloat f -- Y position (+)
jPos2Z=readfloat f -- Z position (+)

jRot1X=radToDeg (readfloat f) -- X rotation (-)
jRot1Y=radToDeg (readfloat f) -- Y rotation (-)
jRot1Z=radToDeg (readfloat f) -- Z rotation (-)

jRot2X=radToDeg (readfloat f) -- X rotation (+)
jRot2Y=radToDeg (readfloat f) -- Y rotation (+)
jRot2Z=radToDeg (readfloat f) -- Z rotation (+)

--Spring ???
sprPosX=readfloat f -- X position
sprPosY=readfloat f -- Y position
sprPosZ=readfloat f -- Z position

sprRotX=readfloat f -- X rotation
sprRotY=readfloat f -- Y rotation
sprRotZ=readfloat f -- Z rotation

append jntNodes(jointInfo \
jName:jntName \
jChild:ph2 \
jParent:ph1 \
jointX:jmx \
jointY:jmz \
jointZ:jmy \
jPos1X:jPos1X \
jPos2X:jPos2X \
jPos1Y:jPos1Z \
jPos2Y:jPos2Z \
jPos1Z:jPos1Y \
jPos2Z:jPos2Y \
jRot1X:jRot1X \
jRot2X:jRot2X \
jRot1Y:jRot1Z \
jRot2Y:jRot2Z \
jRot1Z:jRot1Y \
jRot2Z:jRot2Y \
sprPosX:sprPosX \
sprPosY:sprPosZ \
sprPosZ:sprPosY \
sprRotX:sprRotX \
sprRotY:sprRotZ \
sprRotZ:sprRotY)

)) --ends file end check



if mshON==true AND Vert_array.count!=0 do( -- check if data exsists

msh = mesh vertices:Vert_array faces:Face_array
msh.numTVerts = UV_array.count
buildTVFaces msh
msh.name=mdllNameA
setUserProp msh "Langauge" 1
setUserProp msh "NameA" mdllNameA
setUserPropBuffer msh ((getUserPropBuffer msh)+"\n"+commentsA)

for j = 1 to UV_array.count do setTVert msh j UV_array[j]
for j = 1 to Face_array.count do setTVFace msh j Face_array[j]
for j = 1 to Normal_array.count do setNormal msh j Normal_array[j]

curFace=1
endFace=0
msh.material=mm
-- ambientColor = color 255 255 255
-- backgroundColor = color 240 240 240
-- lightTintColor = color 128 128 128
-- lightLevel = 1.1
ambientColor = color 185 185 185
backgroundColor = color 240 240 240
lightTintColor = color 255 255 255
lightLevel = 0.6
for x =  1 to matIDArray.count do(
endFace+=(matIDArray[x]/3)
for y = curFace to endFace do(
setFaceMatID msh y x
)
curFace+=(matIDArray[x]/3)
)



if morON==true AND morlist.count!=0 do( --checks if data exsists
morA = Morpher ()
morB = Morpher ()
morC = Morpher ()
morD = Morpher ()
morD.name="Eyes"
morC.name="Brows"
morB.name="Mouth"
morA.name="Other"
max modify mode
addModifier msh morA
addModifier msh morB
addModifier msh morC
addModifier msh morD
mcntA=1
mcntB=1
mcntC=1
mcntD=1
for x = 1 to morlist.count do(
select msh
	
if morTypes[x]==1 do(
WM3_MC_BuildFromNode msh.modifiers[#Brows] mcntB morlist[x]
mcntB+=1)
	
if morTypes[x]==2 do(
WM3_MC_BuildFromNode msh.modifiers[#Eyes] mcntA morlist[x]
mcntA+=1)



if morTypes[x]==3 do(
WM3_MC_BuildFromNode msh.modifiers[#Mouth] mcntC morlist[x]
mcntC+=1)


if morTypes[x]==4 do(
WM3_MC_BuildFromNode msh.modifiers[#Other] mcntD morlist[x]
mcntD+=1)
delete morlist[x]
)) --Morph Check

) -- vert check 1



if bonON==true AND boneArray.count!=0 do( -- check if data exsists

BNArr = #()
for x = 1 to boneArray.count do(
tfm = [boneArray[x].boneX,boneArray[x].boneY,boneArray[x].boneZ]

id=boneArray[x].bChild+1
if id==1 do id=boneArray[x].bParent+1
	

if id>=1 then(
tfm2 = [boneArray[id].boneX,boneArray[id].boneY,boneArray[id].boneZ]
bonSize=((distance tfm tfm2)/5)*modelscale
if bonSize>=(0.9*modelscale) do bonSize=(0.9*modelscale)
if bonSize<=(0.15*modelscale) do bonSize=(0.15*modelscale)
)else(
print ("Improper Bone Discovered @ index: "+(x as string)+" > Recovering...")
tfm2 = [boneArray[x].boneX,boneArray[x].boneY,boneArray[x].boneZ]
tfm2+=[0,0,1]
bonSize=0.33*modelscale
id=1
)


if boneArray[x].bChild==0 do (
tfX=tfm[1]+((tfm[1]-tfm2[1])*modelscale)
tfY=tfm[2]+((tfm[2]-tfm2[2])*modelscale)
tfZ=tfm[3]+((tfm[3]-tfm2[3])*modelscale)
bonSize=0.33*modelscale

tfm2=[tfX,tfY,tfZ]
)



newBone = bonesys.createbone	tfm tfm2 (normalize ([1,0,0]))
			newBone.name   = boneArray[x].bName
			newBone.width  = bonSize
			newBone.height = bonSize
-- 			newBone.transform = tfm
					  
			newbone.showlinks = false
			newBone.pos.controller      = TCB_position ()
			newBone.rotation.controller = TCB_rotation ()	-- required for correct animation

			setUserProp newBone "BoneType" boneArray[x].bType
			if boneArray[x].bType==0 do newBone.wirecolor = color 145 200 255
			if boneArray[x].bType==1 do newBone.wirecolor = color 180 255 140
			if boneArray[x].bType==2 do newBone.wirecolor = color 255 97 0
			if boneArray[x].bType==3 do newBone.wirecolor = color 255 255 255
			if boneArray[x].bType==4 do newBone.wirecolor = color 255 212 127
			if boneArray[x].bType==5 do newBone.wirecolor = color 50 105 255
			if boneArray[x].bType==6 do newBone.wirecolor = color 255 147 156
			if boneArray[x].bType==7 do newBone.wirecolor = color 211 211 211
			if boneArray[x].bType==8 do newBone.wirecolor = color 186 84 255
			if boneArray[x].bType==9 do newBone.wirecolor = color 174 165 255
			if (boneArray[x].bParent != -1) then
			newBone.parent = BNArr[boneArray[x].bParent + 1]
append BNArr newBone
)



if frmON==true AND bonON==true do(
for x = 1 to ikNodeArray.count do(
obj=#()
	
for y = 1 to ikCateArray.count do(

if ikCateArray[y][1]==(x) do(
append obj BNArr[(ikCateArray[y][2]+1)]

)
)

rootBones=#()
leadBones=#()
for i = 1 to obj.count do(
found=false
test=obj[i].parent
for i = 1 to obj.count do(
if obj[i]==test do found=true
)
if found==false do (
append rootBones obj[i]
append leadBones test
))
for w = 1 to rootBones.count do(

select rootBones[w]
max modify mode
linkMod = linked_xform ()
addModifier rootBones[w] linkMod
-- rootBones[w].parent = ikNodeArray[x]
-- ikNodeArray[x].parent = rootBones[w]
linkMod.Control = ikNodeArray[x]
linkMod.name = ("Grp: "+ikNodeArray[x].name)
clearSelection()
)))

if iksON==true AND ikArray.count!=0 AND ikArray.count!=1 do(
for x = 1 to ikArray.count do(
ikchain=IKSys.ikChain (BNArr[(ikArray[x][1])]) (BNArr[(ikArray[x][2])]) "IKHISolver"
ikchain.name = (BNArr[(ikArray[x][3])].name)
-- --	ikchain.name = (BNArr[(ikArray[x][3])].name+" helper")
ikchain.transform.controller.goalSize = 1
-- ikchain.parent = BNArr[(ikArray[x][3])]
-- setUserProp (getnodebyname (BNArr[(ikArray[x][3])].name+" helper")) "ignore" true
childs=BNArr[(ikArray[x][3])].children
parent=BNArr[(ikArray[x][3])].parent
childs.parent = ikchain
ikchain.parent = parent
ikchain.showlinks = true
ikchain.wirecolor = color 255 97 0
ikchain.transform.controller.iterations = ikLimits[x][1]
ikchain.transform.controller.swivelAngle = ikLimits[x][2]
setUserProp BNArr[(ikArray[x][3])] "BoneLoop" (ikLimits[x][1] as integer)
setUserProp BNArr[(ikArray[x][3])] "BoneRotation" ikLimits[x][2]
setUserPropBuffer ikchain (getUserPropBuffer BNArr[(ikArray[x][3])])
delete BNArr[(ikArray[x][3])]
deleteItem BNArr ikArray[x][3]
insertItem ikchain BNArr ikArray[x][3]
))


for x = 1 to boneArray.count do(
-- setUserProp BNArr[x] (boneArray[x].bType as string)
-- if (boneArray[x].boneIK)!=0 do(
if (boneArray[x].bType)==5 do(
BNArr[x].rotation.controller = Orientation_Constraint ()
BNArr[x].rotation.controller.relative = on
BNArr[x].rotation.controller.appendTarget (BNArr[(boneArray[x].boneIK+1)]) 100
))

if colON==true AND phyIndex.count!=0 do(
for x = 1 to phyIndex.count do(
idx=phyIndex[x]
if idx==0 do idx=1 -- 0 means attach to nothing, but force to nearest bone.
col=phyMesh[x]
obj=BNArr[idx]
col.pos+=[obj.pos.x,obj.pos.y,obj.pos.z]
pChild=phyMesh[x]
pParent=boneArray[idx]
col.parent = obj
)

if phyON==true AND colON==true do(
for x=1 to jntNodes.count do(
	
	
	
	
max modify mode
obj=Point_Point ()
-- select obj
-- modPanel.setCurrentObject obj
obj.iconSize = 0.1
obj.constraintType = 1
-- obj.showLinks = true
-- obj.showLinksOnly = true
obj.xMin = jntNodes[x].jRot1X
obj.xMax = jntNodes[x].jRot2X
obj.yMin = jntNodes[x].jRot1Y
obj.yMax = jntNodes[x].jRot2Y
obj.zMin = jntNodes[x].jRot1Z
obj.zMax = jntNodes[x].jRot2Z

	
setUserProp obj "PosMinX" jntNodes[x].jPos1X
setUserProp obj "PosMinY" jntNodes[x].jPos1Y
setUserProp obj "PosMinZ" jntNodes[x].jPos1Z
setUserProp obj "PosMaxX" jntNodes[x].jPos2X
setUserProp obj "PosMaxY" jntNodes[x].jPos2Y
setUserProp obj "PosMaxZ" jntNodes[x].jPos2Z
setUserProp obj "SpringPosX" jntNodes[x].sprPosX
setUserProp obj "SpringPosY" jntNodes[x].sprPosY
setUserProp obj "SpringPosZ" jntNodes[x].sprPosZ
setUserProp obj "SpringRotX" jntNodes[x].sprRotX
setUserProp obj "SpringRotY" jntNodes[x].sprRotY
setUserProp obj "SpringRotZ" jntNodes[x].sprRotZ	


-- obj.childBody = getnodebyname phyNames[(jntNodes[x].jChild)] exact:true ignoreCase:false -- Causes Crash in 3dsmax8!!
-- obj.parentBody = getnodebyname phyNames[(jntNodes[x].jParent)] exact:true ignoreCase:false

obj.childBody = collisionObj[(jntNodes[x].jChild)]
obj.parentBody = collisionObj[(jntNodes[x].jParent)]

obj.parentTransform = transMatrix [(jntNodes[x].jointX),(jntNodes[x].jointY),(jntNodes[x].jointZ)]
obj.lockSpaces = on
setTransformLockFlags obj #{1..3}
obj.alignToParentSpace()
obj.name = jntNodes[x].jName

)))



if sknON==true AND mshON==true AND Vert_array.count!=0 do(
select msh
max modify mode
skinMod = skin ()
addModifier msh skinMod
for x = 1 to boneArray.count do (
if x!=boneArray.count
then skinOps.addbone skinMod (BNArr[x]) 0
else skinOps.addbone skinMod (BNArr[x]) 1
)
modPanel.setCurrentObject skinMod
for i = 1 to Weight_array.count do(
w = Weight_array[i]
bi = #() --bone index array
wv = #() --weight value array
for j = 1 to w.boneids.count do	(
boneid = w.boneids[j]
weight = w.weights[j]
append bi boneid
append wv weight
)	
if i==0 do i=1
skinOps.ReplaceVertexWeights skinMod i bi wv
)) -- vert check 2
) -- bone check


if engON==true AND engData==1 do( --renames everything according to english name table
messageBox "Warning!\nNameConversion Not Supported for Export yet\nDo Not Use This Feature\nIf you Plan on Exporting"
if boneArray.count!=0 do( --Renames Bones
for x = 1 to BNArr.count do(
obj=getnodebyname boneArray[x].bName
if engBones[x]!="" do(
setUserProp obj "Langauge" 1
setUserProp obj "Name" obj.name
obj.name=engBones[x]
)))

if morNameArray.count!=0 do( --Renames Bones
if mshON==true then(
for mc = 1 to msh.modifiers.count do(
if classOf msh.modifiers[mc] == Morpher do (
morMod=msh.modifiers[mc]
for x = 1 to 100 do(
morName=WM3_MC_GetName morMod x
if morName!="- empty -" do(
for mr = 2 to morNameArray.count do(
if morNameArray[mr]==morName do(
if engMorphs[mr]!=""do(
WM3_MC_SetName morMod x engMorphs[(mr-1)]
)))))))
)else(
obj=$*
for obm = 1 to obj.count do(
if (classof obj[obm])==Editable_Mesh do(
morName=(findItem morNameArray obj[obm].name)-1
if morName!=0 do(
obj[obm].name=engMorphs[morName]
)))))
) --ends english conversion loop


if hidON==true do(
hideme=#()
for a = 1 to obj.count do(
if (classOf obj[a].baseobject) == Capsule \
or  (classOf obj[a].baseobject) == Sphere \
or  (classOf obj[a].baseobject) == Box \
or (classOf obj[a].baseobject) == Point_Point do append hideme obj[a])
hide hideme
)

)
--===========================================================================
Print ("Last Read @ 0x"+((bit.intAsHex(ftell f))as string))
enableSceneRedraw()
flushLog()
closeLog()
if logON==false do deleteFile (fpath+fname+"_log.txt")
gc()
fclose f
Print ("Done! ("+((((timestamp())-st)/60)as string)+" Seconds)") --print time to finish
))) else (Print "Aborted.")

) -- End of Button Brace
on btn2 pressed do( --PMD Export
st = timestamp() --get start time in milliseconds

ssource = getSaveFileName \
caption:"PMD Exporter" \
types: "Polygon Model Data(*.pmd)|*.PMD|All files (*.*)|*.*|"
if (ssource!=undefined) then(
s = fopen ssource "wb"

obj= $*
errorLog=""
local nrmON=nrmchk.checked
local nrm2ON=nrmchk.checked
local flpON=flpchk.checked

nrm2ON=true
if nrm2ON==true do nrmON=false

modelArray=#()
struct model (
vertX,
vertY,
vertZ,
normX,
normY,
normZ,
tvertU,
tvertV,
boneA,
boneB,
weight
)

matArray=#()
struct materials (
diffR,
diffG,
diffB,
opac,
gloss,
spec,
specR,
specG,
specB,
ambR,
ambG,
ambB,
outline,
toon,
diffTex,
refTex,
refType,
apexes
)

boneArray=#()
struct bon (
bName,
bParent,
bChild,
boneX,
boneY,
boneZ,
boneIK,
bType
)

kineticsArray=#()
struct kinetic (
ikStart,
ikEnd,
ikNum,
ikLoop,
ikLimit
)

rigidBodyArray=#()
struct rigidBody (
colName,
colParent,
colGroup,
colGroupA,
colGroupB,
colShape,
colWidth,
colHeight,
colLength,
colPosX,
colPosY,
colPosZ,
colRotX,
colRotY,
colRotZ,
colMass,
colMDecay,
colRDecay,
colElasticity,
colFriction,
colType
)


physicArray=#()
struct physics (
phyName,
phyPoint1,
phyPoint2,
phyPosX,
phyPosY,
phyPosZ,
phyRotX,
phyRotY,
phyRotZ,
phyPos1X,
phyPos2X,
phyPos1Y,
phyPos2Y,
phyPos1Z,
phyPos2Z,
phyRot1X,
phyRot2X,
phyRot1Y,
phyRot2Y,
phyRot1Z,
phyRot2Z,
sprPosX,
sprPosY,
sprPosZ,
sprRotX,
sprRotY,
sprRotZ)

clearlistener()

num_verts = 0
num_faces = 0
num_tex = 0
faceCount=0 --incorrect naming, more like vert count, increases per mesh
morphCount=0

-- data collection, organize all nodes into seperate arrays
ModelBin=#() 
BoneBin=#()
CollisionBin=#()
ConstraintBin=#()
KineticsBin=#()
NormalBin=#() -- not used, using normsArray
FaceArray=#()
normsArray=#()
NormalSection=#()
-- general arrays, used for data mangment


ikchains=#()
morName=#() -- stores morph names
morCull=#() -- indexes which verts changed from original
morBase=#() -- after morCull is culled, the reduced base list is store here
morIndex=#() -- indexes the morph channels 0=new mod/category
morBuffer=#() -- holds the vert index that changed, and the new pos of vert

ts = timestamp()
for a = 1 to obj.count do( -- Filters Out Nodes
	
if (classOf obj[a].baseobject) == BoneGeometry \
or (classOf obj[a].baseobject) == IK_Chain_Object do append BoneBin obj[a]

if (classOf obj[a].baseobject) == Capsule \
or  (classOf obj[a].baseobject) == Sphere \
or  (classOf obj[a].baseobject) == Box do(
if obj[a].parent!=undefined do append CollisionBin obj[a])
if (classOf obj[a].baseobject) == Point_Point do(
if obj[a].childBody!=undefined AND obj[a].parentBody!=undefined do(
append ConstraintBin obj[a]))

if (classOf obj[a].baseobject) == IK_Chain_Object do append KineticsBin obj[a]
	
	
if (classOf obj[a].baseobject) == Editable_Poly \
or (classOf obj[a].baseobject) == Editable_Mesh do(
for h = 1 to obj[a].modifiers.count do(
	
if classOf obj[a].modifiers[h] == Skin \
AND skinOps.GetNumberBones obj[a].modifiers[h]!=0 do append ModelBin obj[a]
if classOf obj[a].modifiers[h] == Edit_Normals do append NormalSection obj[a]

))
-- "Section 01: Name/Comments @ 0x3"
-- "Section 02: Model Data @ 0x11b"
-- "Section 03: Materials @ 0x530dd"
-- "Section 04: Bones @ 0x53587"
-- "Section 05: IK Chains @ 0x5449e"
-- "Section 06: Morphs @ 0x544d8"
-- "Section 07: Frames @ 0x6bfad"
-- "Section 08: English Names @ 0x6c222"
-- "Section 08b: Bone Names @ 0x6c337"
-- "Section 08c: Morph Names @ 0x6caf3"
-- "Section 08d: IK Chain Names @ 0x6ce3b"
-- "Section 08e: Toon Names @ 0x6cf99"
-- "Section 09: Collision Model @ 0x6d381"
-- "Section 10: Physics @ 0x6d9ae"

)
Print("Node Collection: ("+(((timestamp())-ts)as string)+" Milli Seconds)");ts = timestamp()





if nrmON==true AND NormalSection.count==0 then(
normMod=Edit_Normals()
max modify mode
select ModelBin
modPanel.addModToSelection normMod
normMod.selectBy = 1
for x=1 to ModelBin.count do(
vertCounter=getNumVerts ModelBin[x]
normMod.EditNormalsMod.Unify selection:#{1..vertCounter} node:ModelBin[x]
normMod.EditNormalsMod.SetSelection #{1..vertCounter} node:ModelBin[x]
-- normMod.EditNormalsMod.MakeExplicit selection:#{1..vertCounter} node:ModelBin[x]
normMod.EditNormalsMod.Average useThresh:on threshold:0.001 selection:#{1..vertCounter} node:ModelBin[x])
normMod.EditNormalsMod.AverageGlobal useThresh:on threshold:0.001
for x=1 to ModelBin.count do (
modPanel.setCurrentObject ModelBin[x].modifiers[1]
for y = 1 to ModelBin[x].numverts do(
append NormalBin (ModelBin[x].modifiers[1].getNormal y node:ModelBin[x]))
deleteModifier ModelBin[x] 1
))else(
if nrmON==true then(
for x=1 to ModelBin.count do(
if findItem NormalSection ModelBin[x]!=0 then(
modPanel.setCurrentObject ModelBin[x].modifiers[#Edit_Normals]
-- for y=1 to  ModelBin[x].numverts do(
-- append NormalBin (ModelBin[x].modifiers[#Edit_Normals].getNormal y)
-- 	
-- 	)	
	
	
	
	
	-- http://forums.cgsociety.org/showpost.php?p=3003739&postcount=4
normalindex=#()
normalbuff=#()
normCounter=0
 theEditNormalsModifier = ModelBin[x].modifiers[#Edit_Normals]
   theNumFaces = theEditNormalsModifier.getNumFaces() --get the faces in the modifier
   for f = 1 to theNumFaces do --loop through the faces in the modifier
   (
   for i = 1 to theEditNormalsModifier.getFaceDegree f do --get the vertex number of the face f and loop
   (
   theNormalId = theEditNormalsModifier.GetNormalID f i --get the ID of the vertex normal by index (f,i)
   theVertexId = theEditNormalsModifier.GetVertexID f i --get the vertex ID

   theNormal = theEditNormalsModifier.GetNormal theNormalId --get the normal by ID
   theVertex = theEditNormalsModifier.GetVertex theVertexId --get the vertex by ID
	if theVertexId!=normCounter do
	(
	normCounter=theVertexId
	append normalbuff theNormal
	append normalindex theVertexId
	)
   )--end i	
   )--end f

   for nx = 1 to $.numverts do(
   if findItem normalindex nx!=0 then(
	   append NormalBin normalbuff[(findItem normalindex nx)]
	   
	   )else(
	   
append NormalBin (getNormal ModelBin[x] y)
	   
	   
	   
	)
   
--    print "resluit"
--    print normal.count
-- print normal
	   
	   
   )
	
	
	
	
	
	
	

)else(

for y=1 to  ModelBin[x].numverts do(
append NormalBin (getNormal ModelBin[x] y)
)
	)
	
	
	
	
)	
	
)else(

print "....................using vert welding"
for x=1 to ModelBin.count do(
normalindex=#()
normalbuff=#()
normCounter=0
tmesh = snapshotAsMesh ModelBin[x]
if findItem NormalSection ModelBin[x]!=0 then(
for y=1 to tmesh.numverts do(
append normalindex (getVert tmesh y)
append normalbuff (getNormal tmesh y)
)
for y=1 to tmesh.numverts do(
find=findItem normalindex (getVert tmesh y)
if find!=0 then(
 append NormalBin (normalbuff[find])
	
	
)else(
append NormalBin (getNormal tmesh y)
	)

	
)
	
	
)else(
for y=1 to tmesh.numverts do(
append NormalBin (getNormal tmesh y)
)
)

delete tmesh
normalindex=#()
normalbuff=#()



)


)








)

-- else(

-- for mh = 1 to ModelBin.count do(
-- normMod=undefined
-- for i =1 to ModelBin[mh].modifiers.count do(
-- if classOf ModelBin[mh].modifiers[i] == Edit_Normals do(
-- append NormalSection ModelBin[mh] --this array doesnt do anything, but is still used during a if check..
-- normMod=ModelBin[mh].modifiers[i]
-- ))


-- -- if findItem NormalSection ModelBin[mh]!=0 then(
-- if normMod!=undefined then(
-- for y = 1 to ModelBin[mh].numverts do(
-- append NormalBin (normMod.getNormal y)
-- ))else(
-- for x=1 to ModelBin[mh].numverts do(
-- append NormalBin (getNormal ModelBin[mh] x)))))
	
	
Print("Normal Collection: ("+(((timestamp())-ts)as string)+" Milli Seconds)");ts = timestamp()

texcoord=[0,0,0]
for mh = 1 to ModelBin.count do( -- stores mesh data to array. ready for mesh export.
ts = timestamp()
vertIndexWeights=#() -- vertex [vertexID,Weight1]
vertWeights=#() -- vertex [vertexID,Weight1]
skinBones=#() -- bones used in skin modifier


msh = ModelBin[mh]
skinMod=""
for ch = 1 to msh.modifiers.count do(
if classOf msh.modifiers[ch] == Skin do skinMod=msh.modifiers[ch]
)
Print("Modifier Calculation: ("+(((timestamp())-ts)as string)+" Milli Seconds)");ts = timestamp()

select msh
max modify mode
Print("modify mode: ("+(((timestamp())-ts)as string)+" Milli Seconds)");ts = timestamp()
modPanel.setCurrentObject skinMod

Print("WeightPrep: ("+(((timestamp())-ts)as string)+" Milli Seconds)");ts = timestamp()

skinMod.bone_Limit = 2
skinMod.clearZeroLimit = 0.0
skinOps.RemoveZeroWeights skinMod
modPanel.setCurrentObject skinMod
bones_total_count = skinops.getnumberbones skinMod
vertex_count = getNumverts msh --getnumvertices




-- loop through all mesh vertices in this mesh

Print("PostWeight Calculation: ("+(((timestamp())-ts)as string)+" Milli Seconds)");ts = timestamp()


for i = 1 to vertex_count do(
-- loop through all bones affecting this vertex
vertex_bone_count = skinOps.GetVertexWeightCount skinMod i
	

for bn = 1 to vertex_bone_count do(
weight = skinops.getvertexweight skinMod i bn

vertex_bone_id = skinOps.GetVertexWeightBoneID  skinMod i bn



selectBone=skinOps.GetBoneName skinMod vertex_bone_id 0
	
append vertWeights weight
append vertIndexWeights i
append skinBones selectBone
)
-- print "done"
)
Print("Weight Index Calculation: ("+(((timestamp())-ts)as string)+" Milli Seconds)");ts = timestamp()

morCount=0
for mc = 1 to msh.modifiers.count do(
	
	
	
if classOf msh.modifiers[mc] == Morpher do (
morphCount=FaceCount
append morIndex 0
morMod=msh.modifiers[mc]
for x = 1 to 100 do(
if (WM3_MC_NumMPts morMod x)==(getNumVerts msh) do(
append morName (WM3_MC_GetName morMod x)
morCount=0
for ml = 1 to (WM3_MC_NumMPts morMod x) do(
remainder=(((WM3_MC_GetMorphPoint morMod x (ml-1))+msh.pos)-(getVert msh ml))
getPos=getVert msh ml
if (((remainder.x+remainder.y+remainder.z)*1000000)as integer)!=0 do (
append morCull ml
append morBuffer[ml, \
((((WM3_MC_GetMorphPoint morMod x (ml-1))+msh.pos).x)-getPos.x), \
((((WM3_MC_GetMorphPoint morMod x (ml-1))+msh.pos).z)-getPos.z), \
((((WM3_MC_GetMorphPoint morMod x (ml-1))+msh.pos).y)-getPos.y)]
morCount+=1
))
append morIndex morCount
))



)



)
Print("Morph Calculation: ("+(((timestamp())-ts)as string)+" Milli Seconds)");ts = timestamp()
if morCull.count!=0 do(
for ma = 1 to (getNumVerts msh) do(
if (findItem morCull ma)!=0 do append morBase ma
))
Print("Morph Culling: ("+(((timestamp())-ts)as string)+" Milli Seconds)");ts = timestamp()


boneID=#() -- bones used in skin modifier, as ID relating to BoneBin
for sc = 1 to skinBones.count do( -- converts the skin list to IDs, based on master bone list
for mt = 1 to BoneBin.count do(
if skinBones[sc]==BoneBin[mt].name do append boneID (mt-1)
	

))
Print("Skin Bone Calculation: ("+(((timestamp())-ts)as string)+" Milli Seconds)");ts = timestamp()





tmesh = snapshotAsMesh ModelBin[mh]	
num_verts = tmesh.numverts
num_faces = tmesh.numfaces
num_tex = tmesh.numtverts
norm=undefined
print "CHECK"
print ModelBin[mh].name
print ModelBin[mh].numverts
print NormalBin.count
-- if nrmON=false AND NormalSection.count!=0 do(
-- if findItem NormalSection ModelBin[mh]!=0 do(
-- modPanel.setCurrentObject ModelBin[mh].modifiers[#Edit_Normals]))
for rd = 1 to num_verts do(
vert = getVert tmesh rd
if NormalBin.count==0 then(
norm = getNormal tmesh rd
)else(
norm=NormalBin[1]
deleteItem NormalBin 1	
)
-- norm = normMod.GetNormal rd
-- if nrmON==false OR NormalSection.count!=0 then(
-- if findItem NormalSection ModelBin[mh]!=0 then(
-- norm=(ModelBin[mh].modifiers[#Edit_Normals].getNormal rd)
-- --	norm = getNormal tmesh rd
-- 	
-- 	

-- )else(
-- norm = getNormal tmesh rd

-- )
-- 	
-- 	
-- )else(

-- 	)
-- 	normM=findItem normsArray vert
-- append normsArray vert
-- append NormalBin norm

-- if normM!=0 do (
-- norm = NormalBin[normM]
-- 	norm = getNormal tmesh normM
-- 	deleteItem normsArray normM
-- 	)

if num_tex!=0 then(
num=rd
if rd>=num_tex do num=num_tex
texcoord = getTVert tmesh num
if texcoord==undefined do texcoord=[0,0,0]
	
	
	
	)else(texcoord=[0,0,0])
nx=norm.x
ny=norm.z
nz=norm.y
vx=vert.x
vy=vert.z
vz=vert.y
tu=texcoord.x
tv=texcoord.y
if flpON!=true do tv=tv*-1

-- if (getNumTVerts $)==(getNumVerts $)
-- then messagebox "Good!"
-- else messagebox "FUCK!"

	
	
	
newWeights=#()
find=undefined
do(
if keyboard.escPressed then exit
find=(findItem vertIndexWeights rd)
if find!=0 do(
append newWeights[(boneID[find]),(vertWeights[find])]
deleteItem vertIndexWeights find
deleteItem vertWeights find
deleteItem boneID find
))while find!=0 

-- for y = 1 to vertWeights.count do(
-- if rd==vertIndexWeights[y] do append newWeights[(boneID[y]),(vertWeights[y])]
-- )


if newWeights.count==1 then(
b1=newWeights[1][1]
b2=0
w1=1
)else(
-- if newWeights.count==2 do(
b1=newWeights[1][1]
b2=newWeights[2][1]
w1=newWeights[1][2]
)
-- if newWeights.count==3 do(
-- 	b1=newWeights[1][1]
-- b2=newWeights[2][1]
-- w1=newWeights[1][2]
	
	
	
-- col=#()

-- if vertWeights[1][2]>=vertWeights[2][2] then(
-- if vertWeights[3][2]>=vertWeights[2][2] then(
-- append col[(vertWeights[3][1]),(vertWeights[3][2])])
-- else(append col[(vertWeights[2][1]),(vertWeights[2][2])])
-- append col[(vertWeights[1][1]),(vertWeights[1][2])])else(
-- if vertWeights[3][2]>=vertWeights[1][2] 
-- then(append col[(vertWeights[3][1]),(vertWeights[3][2])])
-- else(append col[(vertWeights[1][1]),(vertWeights[1][2])])
-- append col[(vertWeights[2][1]),(vertWeights[2][2])]
-- )	

-- b1=col[1][1]
-- b2=col[2][1]
-- w1=(((1-(col[1][2]+col[2][2]))/2)+col[1][2])
-- )
-- if newWeights.count==4 do(
-- 	b1=newWeights[1][1]
-- b2=newWeights[2][1]
-- w1=newWeights[1][2]
	
	
	
-- col=#()
-- colB=#()
-- if vertWeights[1][2]>=vertWeights[2][2] then(
-- if vertWeights[3][2]>=vertWeights[2][2] then(
-- if vertWeights[4][2]>=vertWeights[3][2] 
-- then(append col[(vertWeights[4][1]),(vertWeights[4][2])])
-- else(append col[(vertWeights[3][1]),(vertWeights[3][2])])
-- append col[(vertWeights[3][1]),(vertWeights[3][2])]
-- )else(
-- if vertWeights[4][2]>=vertWeights[2][2] 
-- then(append col[(vertWeights[4][1]),(vertWeights[4][2])])
-- else(append col[(vertWeights[2][1]),(vertWeights[2][2])])
-- append col[(vertWeights[2][1]),(vertWeights[2][2])]
-- )
-- append col[(vertWeights[1][1]),(vertWeights[1][2])]
-- )else(
-- if vertWeights[3][2]>=vertWeights[1][2] then(
-- if vertWeights[4][2]>=vertWeights[3][2] 
-- then(append col[(vertWeights[4][1]),(vertWeights[4][2])])
-- else(append col[(vertWeights[3][1]),(vertWeights[3][2])])
-- append col[(vertWeights[3][1]),(vertWeights[3][2])]
-- )else(
-- if vertWeights[4][2]>=vertWeights[2][2] 
-- then(append col[(vertWeights[4][1]),(vertWeights[4][2])])
-- else(append col[(vertWeights[2][1]),(vertWeights[2][2])])
-- append col[(vertWeights[1][1]),(vertWeights[1][2])]
-- )
-- append col[(vertWeights[2][1]),(vertWeights[2][2])]
-- )
-- if col[1][2]>=col[2][2] then(
-- if col[3][2]>=col[2][2] then(
-- append colB[(col[3][1]),(col[3][2])])
-- else(append colB[(col[2][1]),(col[2][2])])
-- append colB[(col[1][1]),(col[1][2])])else(
-- if col[3][2]>=col[1][2] 
-- then(append colB[(col[3][1]),(col[3][2])])
-- else(append colB[(col[1][1]),(col[1][2])])
-- append colB[(col[2][1]),(col[2][2])]
-- )	
-- b1=colB[1][1]
-- b2=colB[2][1]
-- w1=(((1-(colB[1][2]+colB[2][2]))/2)+colB[1][2])
-- if w1>=1 do w1=1
-- )

w1=((w1)*100) as integer


append modelArray (model vertX:vx vertY:vy vertZ:vz normX:nx normY:ny normZ:nz tvertU:tu tvertV:tv boneA:b1 boneB:b2 weight:w1)
	)
-- subobjectLevel = 0
-- deleteModifier msh 1
Print("Weight Calculation: ("+(((timestamp())-ts)as string)+" Milli Seconds)");ts = timestamp()
	
	

	
msh =  ModelBin[mh]
if msh.material == undefined then (
mat=meditMaterials[1] = Standardmaterial ()
mat.Diffuse=msh.wirecolor
mat.ambient=msh.wirecolor
matCount=1
)else(
mat=msh.material	
)

matType=0


	
diffMap=""
reflMap=""
refrMap=""
reflAlpha=0







facesBin=#()
matApexes=#()
matIDarray=#()
sortMats=#()
sortFaces=#()
matCount=0



if classof mat == NoMaterial do matType=1
if classof mat == Standard do matCount=1
if classof mat == InkNPaint do matType=4
if classof mat == Blend  do matType=5
if classof mat == MultiMaterial do (

for f = 1 to num_faces do(
matID=getFaceMatID tmesh f
if matCount!=matID do append matIDarray matID
append sortMats matID
append sortFaces f
)

sortMatIDs=copy matIDarray #nomap 
sort sortMatIDs
matIDarray=#()
matID=undefined
for x=1 to sortMats.count do(
if sortMatIDs[x]!=matID do append matIDarray sortMatIDs[x]
matID=sortMatIDs[x]
)

for x = 1 to matIDarray.count do(
matCount=0
matID=undefined
do(
if keyboard.escPressed then exit
matID=findItem sortMats matIDarray[x]
if matID!=0 do(
matCount+=1
append facesBin sortFaces[matID]
deleteItem sortMats matID
deleteItem sortFaces matID
))while matID!=0
if matCount!=0 do append matApexes matCount
)

for f = 1 to facesBin.count do(
face = getFace tmesh (facesBin[f])
append FaceArray (face+faceCount)
)


matCount=matApexes.count
)





for m = 1 to matCount do(
if matCount!=1 then (subM=mat.materialList[(matIDarray[m])]) else (subM=mat )

matGroup=0

outline=subM.twoSided
if outline==true then outline=1 else outline=0
if subM.diffuseMap!=undefined do diffMap=filenameFromPath subM.diffuseMap.fileName
if subM.reflectionMap!=undefined do (
reflMap=filenameFromPath subM.reflectionMap.fileName
reflAlpha=subM.reflectionMap.alphaSource
)
if subM.refractionMap!=undefined do refrMap=filenameFromPath subM.refractionMap.fileName

if classof mat == MultiMaterial then (
-- for f = 1 to num_faces do(
-- if (getFaceMatID tmesh f)==m do(
-- matGroup+=1
-- face = getFace tmesh f
-- append FaceArray (face+faceCount)
-- ))
matGroup=matApexes[m]

)else(
matGroup=num_faces
for f = 1 to num_faces do(
append FaceArray ((getFace tmesh f)+faceCount)
))


append matArray(materials \
diffR:((subM.ambient.red)/255) \
diffG:((subM.ambient.green)/255) \
diffB:((subM.ambient.blue)/255) \
opac:((subM.opacity)/100) \
gloss:subM.glossiness \
spec:subM.specularLevel  \
specR:((subM.Specular.red)/255) \
specG:((subM.Specular.green)/255) \
specB:((subM.Specular.blue)/255) \
ambR:((subM.Diffuse.red)/255) \
ambG:((subM.Diffuse.green)/255) \
ambB:((subM.Diffuse.blue)/255) \
outline:outline \
toon:refrMap \
diffTex:diffMap \
refTex:reflMap \
refType:reflAlpha \
apexes:(matGroup*3) )








	)
	
Print("Material Calculation: ("+(((timestamp())-ts)as string)+" Milli Seconds)");ts = timestamp()
	
	
	
	
	
	
















faceCount+=num_verts
delete tmesh
)
Print("Mesh Calculation: ("+(((timestamp())-ts)as string)+" Milli Seconds)");ts = timestamp()

for kr = 1 to KineticsBin.count do(
numIK=2
ikbone=KineticsBin[kr].transform.controller.endJoint
while ikbone!=KineticsBin[kr].transform.controller.startJoint do(
-- if keyboard.escPressed then exit
append ikchains ikbone
ikbone=ikbone.parent
numIK+=1
)
append ikchains ikbone

ikGoal=(findItem BoneBin ((KineticsBin[kr]))-1)
endIK=(findItem BoneBin ((KineticsBin[kr].transform.controller.endJoint))-1)

ukn1=KineticsBin[kr].transform.controller.iterations
ukn2=KineticsBin[kr].transform.controller.swivelAngle
if ukn2==0 do ukn2=0.1

append kineticsArray (kinetic ikStart:ikGoal ikEnd:endIK ikNum:numIK ikLoop:ukn1 ikLimit:ukn2)
)

for br = 1 to BoneBin.count do(
kidCount=0
bName=BoneBin[br].name

if BoneBin[br].parent!=undefined then(
bParent = (findItem BoneBin ((BoneBin[br].parent))-1))
else(
bParent = -1
)
for kb = 1 to (BoneBin[br].children).count do(
if classof BoneBin[br].children[kb] == BoneGeometry do kidCount+=1
)
if kidCount==1 then(
bChild = (findItem BoneBin (BoneBin[br].children[1])-1)	
)else(
if (BoneBin[br].children).count>=1 then(
child=0
for lob = 1 to (BoneBin[br].children).count do(
childbone=(BoneBin[br].children[lob])	
if classof childbone == BoneGeometry do(
if (childbone.children).count<=0 do (
child=(findItem BoneBin (childbone)-1)
)))
bChild = child
)else(bChild = 0))


if (getUserProp BoneBin[br] "BoneType")!=undefined then(
bType = (getUserProp BoneBin[br] "BoneType")
)else(
bType=0
if BoneBin[br].parent==undefined do bType=1
if classOf BoneBin[br].rotation.controller == Orientation_Constraint \
AND (BoneBin[br].rotation.controller.getNode 1)!=undefined do bType=5
if classOf BoneBin[br].transform.controller == IKChainControl do bType=2

if (BoneBin[br].children).count<=0 do bType=7
if classOf BoneBin[br].transform.controller == IKControl do bType=4
if classOf BoneBin[br].transform.controller == IKControl \
AND (BoneBin[br].children).count<=0 do bType=6
)


boneIK=0
if classOf BoneBin[br].rotation.controller == Orientation_Constraint \
AND (BoneBin[br].rotation.controller.getNode 1)!=undefined do (
boneIK=((findItem BoneBin (BoneBin[br].rotation.controller.getNode 1))-1)
)
	
if classOf BoneBin[br].transform.controller == IKControl do (

for kt = 1 to KineticsBin.count do(
iksearch=#()
ikbone=KineticsBin[kt].transform.controller.endJoint
while ikbone!=KineticsBin[kt].transform.controller.startJoint do(
-- if keyboard.escPressed then exit
append iksearch ikbone
ikbone=ikbone.parent
)
append iksearch ikbone
if (findItem iksearch BoneBin[br])!=0 do boneIK=((findItem BoneBin (KineticsBin[kt]))-1)
))












	

boneX=BoneBin[br].pos.x
boneY=BoneBin[br].pos.z
boneZ=BoneBin[br].pos.y
	
	
append boneArray (bon bName:bName bParent:bParent bChild:bChild boneX:boneX boneY:boneY boneZ:boneZ boneIK:boneIK bType:bType)
)
Print("Bone Calculation: ("+(((timestamp())-ts)as string)+" Milli Seconds)");ts = timestamp()

for cr = 1 to CollisionBin.count do(
obj=CollisionBin[cr]
grp0=0
grpA=0
grpB=0
colWidth=0
colHeight=0
colLength=0
colType=0
colMass=0.1
colMDecay=0.5
colRDecay=0.5
colElasticity=0.0
colFriction=0.5

if (classOf obj.baseobject) == Sphere do(
colShape=0
colWidth=obj.radius
)
if (classOf obj.baseobject) == Box do(
colShape=1
colWidth=(abs (obj.width/2))
colHeight=(abs (obj.height/2))
colLength=(abs (obj.length/2))
)
if (classOf obj.baseobject) == Capsule do(
colShape=2
colWidth=obj.radius
colHeight=(abs (obj.height/1.3))
)

colX=obj.center.x-obj.parent.pos.x
colY=obj.center.y-obj.parent.pos.y
colZ=obj.center.z-obj.parent.pos.z

-- colX=obj.center.x
-- colY=obj.center.y
-- colZ=obj.center.z

if (getUserProp obj "Mass")!=undefined do(
colMass=(getUserProp obj "Mass"))
if (getUserProp obj "Friction")!=undefined do(
colFriction=(getUserProp obj "Friction"))
if (getUserProp obj "Stiffness")!=undefined do(
colElasticity=(getUserProp obj "Stiffness"))
if (getUserProp obj "RotDecay")!=undefined do(
colRDecay=(getUserProp obj "RotDecay"))
if (getUserProp obj "PosDecay")!=undefined do(
colMDecay=(getUserProp obj "PosDecay"))
if (getUserProp obj "ActiveGroup")!=undefined do(
grp0=(getUserProp obj "ActiveGroup"))
if (getUserProp obj "Type")!=undefined do(
colType=(getUserProp obj "Type"))
if (getUserProp obj "EffectGroup1")==true do grpA+=1
if (getUserProp obj "EffectGroup2")==true do grpA+=2
if (getUserProp obj "EffectGroup3")==true do grpA+=4
if (getUserProp obj "EffectGroup4")==true do grpA+=8
if (getUserProp obj "EffectGroup5")==true do grpA+=16
if (getUserProp obj "EffectGroup6")==true do grpA+=32
if (getUserProp obj "EffectGroup7")==true do grpA+=64
if (getUserProp obj "EffectGroup8")==true do grpA+=128
if (getUserProp obj "EffectGroup9")==true do grpB+=1
if (getUserProp obj "EffectGroup10")==true do grpB+=2
if (getUserProp obj "EffectGroup11")==true do grpB+=4
if (getUserProp obj "EffectGroup12")==true do grpB+=8
if (getUserProp obj "EffectGroup13")==true do grpB+=16
if (getUserProp obj "EffectGroup14")==true do grpB+=32
if (getUserProp obj "EffectGroup15")==true do grpB+=64
if (getUserProp obj "EffectGroup16")==true do grpB+=128
grpA=255-grpA
grpB=255-grpB

linkage=obj.parent
obj.parent=undefined
-- rx=(((obj.rotation as eulerAngles).x))
-- ry=(((obj.rotation as eulerAngles).y))
-- rz=(((obj.rotation as eulerAngles).z))
-- if rx<0 do rx=(180-(abs rx))+180
-- if ry<0 do ry=(180-(abs ry))+180
-- if rz<0 do rz=(180-(abs rz))+180
rx=(obj.transform.rotationPart as eulerAngles).x
ry=(obj.transform.rotationPart as eulerAngles).y
rz=(obj.transform.rotationPart as eulerAngles).z
if rx<0 do rx=((180-(abs rx))+180)
if ry<0 do ry=((180-(abs ry))+180)
if rz<0 do rz=((180-(abs rz))+180)
rx=rx-180
ry=ry-180
rz=rz-180
print results

print rx
print ry
print rz 



rx=degToRad rx
ry=degToRad ry
rz=degToRad rz
obj.parent=linkage

append rigidBodyArray  (rigidBody \
colName:obj.name \
colParent:((findItem BoneBin obj.parent)-1) \
colGroup:grp0 \
colGroupA:grpA \
colGroupB:grpB \
colShape:colShape \
colWidth:colWidth \
colHeight:colHeight \
colLength:colLength \
colPosX:colX \
colPosY:colZ \
colPosZ:colY \
colRotX:rx \
colRotY:rz \
colRotZ:ry \
colMass:colMass \
colMDecay:colMDecay \
colRDecay:colRDecay \
colElasticity:colFriction \
colFriction:colElasticity \
colType:colType )
	
)




for cr = 1 to ConstraintBin.count do(
phyObj=ConstraintBin[cr]
rotateLimitX=0
rotateLimitY=0
rotateLimitZ=0
moveLimit1X=0
moveLimit2X=0
moveLimit1Y=0
moveLimit2Y=0
moveLimit1Z=0
moveLimit2Z=0
rotateLimit1X=0
rotateLimit2X=0
rotateLimit1Y=0
rotateLimit2Y=0
rotateLimit1Z=0
rotateLimit2Z=0
springPosLimitX=0
springPosLimitY=0
springPosLimitZ=0
springRotLimitX=0
springRotLimitY=0
springRotLimitZ=0
	
if phyObj.constraintType == 1 do(
rotateLimit1X=(degToRad phyObj.xMin)
rotateLimit2X=(degToRad phyObj.xMax)
rotateLimit1Y=(degToRad phyObj.yMin)
rotateLimit2Y=(degToRad phyObj.yMax)
rotateLimit1Z=(degToRad phyObj.zMin)
rotateLimit2Z=(degToRad phyObj.zMax)
)

if (getUserProp phyObj "SpringPosX")!=undefined do(
springPosLimitX=getUserProp phyObj "SpringPosX")
if (getUserProp phyObj "SpringPosY")!=undefined do(
springPosLimitY=getUserProp phyObj "SpringPosY")
if (getUserProp phyObj "SpringPosZ")!=undefined do(
springPosLimitZ=getUserProp phyObj "SpringPosZ")
if (getUserProp phyObj "SpringRotX")!=undefined do(
springRotLimitX=getUserProp phyObj "SpringRotX")
if (getUserProp phyObj "SpringRotY")!=undefined do(
springRotLimitY=getUserProp phyObj "SpringRotY")
if (getUserProp phyObj "SpringRotZ")!=undefined do(
springRotLimitZ=getUserProp phyObj "SpringRotZ")


if (getUserProp phyObj "PosMinX")!=undefined do(
moveLimit1X=getUserProp phyObj "PosMinX")
if (getUserProp phyObj "PosMaxX")!=undefined do(
moveLimit2X=getUserProp phyObj "PosMaxX")
if (getUserProp phyObj "PosMinY")!=undefined do(
moveLimit1Y=getUserProp phyObj "PosMinY")
if (getUserProp phyObj "PosMaxY")!=undefined do(
moveLimit2Y=getUserProp phyObj "PosMaxY")
if (getUserProp phyObj "PosMinZ")!=undefined do(
moveLimit1Z=getUserProp phyObj "PosMinZ")
if (getUserProp phyObj "PosMaxZ")!=undefined do(
moveLimit2Z=getUserProp phyObj "PosMaxZ")

print "PRINING SHITR NFBFBDFDFDF"
phyP1=((findItem CollisionBin phyObj.parentBody)-1)
phyP2=((findItem CollisionBin phyObj.childBody)-1)

if phyP1==-1 or phyP2==-1 do(
print phyObj
print phyObj.parentBody
print phyObj.childBody
	
	
)

append physicArray (physics \
phyName:phyObj.name \
phyPoint1:((findItem CollisionBin phyObj.parentBody)-1) \
phyPoint2:((findItem CollisionBin phyObj.childBody)-1) \
phyPosX:phyObj.pos.x \
phyPosY:phyObj.pos.z \
phyPosZ:phyObj.pos.y \
phyRotX:rotateLimitX \
phyRotY:rotateLimitZ \
phyRotZ:rotateLimitY \
phyPos1X:moveLimit1X \
phyPos2X:moveLimit2X \
phyPos1Y:moveLimit1Z \
phyPos2Y:moveLimit2Z \
phyPos1Z:moveLimit1Y \
phyPos2Z:moveLimit2Y \
phyRot1X:rotateLimit1X \
phyRot2X:rotateLimit2X \
phyRot1Y:rotateLimit1Z \
phyRot2Y:rotateLimit2Z \
phyRot1Z:rotateLimit1Y \
phyRot2Z:rotateLimit2Y \
sprPosX:springPosLimitX \
sprPosY:springPosLimitZ \
sprPosZ:springPosLimitY \
sprRotX:springRotLimitX \
sprRotY:springRotLimitZ \
sprRotZ:springRotLimitY)
)
Print("Collision Model Calculation: ("+(((timestamp())-ts)as string)+" Milli Seconds)");ts = timestamp()



testname="test"
comment="Test File, gn?"

writestring s "Pmd";fseek s -1 #seek_cur --IDs File
writefloat s 1 -- File Version?

writestring s testname
for x = 1 to (20-(testname.count+1)) do(writebyte s -3)
writestring s comment
for x = 1 to (256-(comment.count+1)) do(writebyte s -3)

	
	
writelong s ModelArray.count
for wr = 1 to ModelArray.count do(
writefloat s ModelArray[wr].vertX
writefloat s ModelArray[wr].vertY
writefloat s ModelArray[wr].vertZ
writefloat s ModelArray[wr].normX
writefloat s ModelArray[wr].normY
writefloat s ModelArray[wr].normZ
writefloat s ModelArray[wr].tvertU
writefloat s ModelArray[wr].tvertV
writeshort s ModelArray[wr].boneA
writeshort s ModelArray[wr].boneB
writeshort s ModelArray[wr].weight
)

writelong s (FaceArray.count*3)
for wr = 1 to FaceArray.count do(
writeshort s (FaceArray[wr][1]-1)
writeshort s (FaceArray[wr][3]-1)
writeshort s (FaceArray[wr][2]-1)
)


writelong s matArray.count
for wr = 1 to matArray.count do(
writefloat s matArray[wr].diffR
writefloat s matArray[wr].diffG
writefloat s matArray[wr].diffB
writefloat s matArray[wr].opac
writefloat s matArray[wr].gloss
writefloat s matArray[wr].specR
writefloat s matArray[wr].specG
writefloat s matArray[wr].specB
writefloat s matArray[wr].ambR
writefloat s matArray[wr].ambG
writefloat s matArray[wr].ambB
writebyte s 0
writebyte s matArray[wr].outline
writelong s matArray[wr].apexes
-- writebyte s 0
-- for x = 1 to 19 do (writebyte s -3)



matTex=""
if matArray[wr].diffTex!="" do matTex+=matArray[wr].diffTex
-- if matArray[wr].diffTex!="" AND matArray[wr].refTex!="" do matTex+="*"
-- if matArray[wr].refTex!="" do matTex+=matArray[wr].refTex
if matTex.count>=20 do matTex=(readChars (matTex as stringstream) 20) as string

print matTex
getPos=ftell s
writestring s matTex
for x = 1 to (21-(matTex.count)) do (writebyte s -3)
fseek s (getPos+20) #seek_set

)


writeshort s boneArray.count
for wr = 1 to boneArray.count do(
getPos=ftell s
writestring s boneArray[wr].bName
for x = 1 to (20-((boneArray[wr].bName).count)+1) do (writebyte s -3)
fseek s (getPos+20) #seek_set
writeshort s boneArray[wr].bParent
writeshort s boneArray[wr].bChild
writebyte s boneArray[wr].bType
writeshort s boneArray[wr].boneIK
writefloat s boneArray[wr].boneX
writefloat s boneArray[wr].boneY
writefloat s boneArray[wr].boneZ
)

ikCount=2
writeshort s kineticsArray.count
for kr = 1 to kineticsArray.count do(
writeshort s kineticsArray[kr].ikStart
writeshort s kineticsArray[kr].ikEnd
writebyte s (kineticsArray[kr].ikNum-2)
writeshort s kineticsArray[kr].ikLoop
writefloat s kineticsArray[kr].ikLimit
for y = ikCount to ((ikCount-1)+(kineticsArray[kr].ikNum-2)) do(
writeshort s (findItem BoneBin (ikchains[y])-1))
ikCount+=(kineticsArray[kr].ikNum-1)
)















mCount=1
mGroup=0
mIndex=0
if morIndex.count!=0 then writeshort s (morName.count+1) else writeshort s 0
if morIndex.count!=0 do(
writestring s "base"
for x = 1 to 15 do (writebyte s -3)
writelong s morBase.count
writebyte s mGroup
for mb = 1 to morBase.count do(
writelong s (((morBase[mb])-1)+morphCount)
writefloat s ModelArray[((morBase[mb])+morphCount)].vertX
writefloat s ModelArray[((morBase[mb])+morphCount)].vertY
writefloat s ModelArray[((morBase[mb])+morphCount)].vertZ
)

for wm = 1 to morIndex.count do(
if morIndex[wm]==0 then (
mGroup+=1
mCount+=1

)else(


getPos=ftell s
writestring s morName[(mCount-mGroup)]
for x = 1 to (20-((morName[(mCount-mGroup)]).count)+1) do (writebyte s -3)
fseek s (getPos+20) #seek_set
writelong s morIndex[wm]
writebyte s mGroup
for wmi = 1 to morIndex[wm] do(
mIndex+=1
writelong s ((findItem morBase (morBuffer[mIndex][1]))-1)
writefloat s morBuffer[mIndex][2]
writefloat s morBuffer[mIndex][3]
writefloat s morBuffer[mIndex][4]

)
-- mIndex+=morIndex[(mCount-mGroup)]
mCount+=1
)


)



)































writebyte s 0 --skips bone index for frames
writebyte s 0 --frame names
writelong s 0 --skips frames index








writebyte s 1 ---english ON!
engName="english title"
engComment="< ZOMG TYPING SPACE >"
WriteFixedString s 20 engName
WriteFixedString s 256 engComment

for x = 1 to boneArray.count do(
WriteFixedString s 20 boneArray[x].bName
)
for x = 1 to morName.count do(
WriteFixedString s 20 morName[x]
)
for x = 1 to 0 do(
WriteFixedString s 50 "frames not implemented yet"
)
for x = 1 to 10 do(
if x<=10 then(
WriteFixedString s 100 ("toon0"+(x as string)+".bmp")
)else(WriteFixedString s 100 "toon10.bmp"))



writelong s rigidBodyArray.count
for wb = 1 to rigidBodyArray.count do(
WriteFixedString s 20 rigidBodyArray[wb].colName
writeshort s rigidBodyArray[wb].colParent
writebyte s rigidBodyArray[wb].colGroup
writebyte s rigidBodyArray[wb].colGroupA
writebyte s rigidBodyArray[wb].colGroupB
writebyte s rigidBodyArray[wb].colShape
writefloat s rigidBodyArray[wb].colWidth
writefloat s rigidBodyArray[wb].colHeight
writefloat s rigidBodyArray[wb].colLength
writefloat s rigidBodyArray[wb].colPosX
writefloat s rigidBodyArray[wb].colPosY
writefloat s rigidBodyArray[wb].colPosZ
writefloat s rigidBodyArray[wb].colRotX
writefloat s rigidBodyArray[wb].colRotY
writefloat s rigidBodyArray[wb].colRotZ
writefloat s rigidBodyArray[wb].colMass
writefloat s rigidBodyArray[wb].colMDecay
writefloat s rigidBodyArray[wb].colRDecay
writefloat s rigidBodyArray[wb].colElasticity
writefloat s rigidBodyArray[wb].colFriction
writebyte s rigidBodyArray[wb].colType	
)


writelong s physicArray.count
for wp = 1 to physicArray.count do(
WriteFixedString s 20 physicArray[wp].phyName
writelong s physicArray[wp].phyPoint1
writelong s physicArray[wp].phyPoint2
writefloat s physicArray[wp].phyPosX
writefloat s physicArray[wp].phyPosY
writefloat s physicArray[wp].phyPosZ
writefloat s physicArray[wp].phyRotX
writefloat s physicArray[wp].phyRotY
writefloat s physicArray[wp].phyRotZ
writefloat s physicArray[wp].phyPos1X
writefloat s physicArray[wp].phyPos1Y
writefloat s physicArray[wp].phyPos1Z
writefloat s physicArray[wp].phyPos2X
writefloat s physicArray[wp].phyPos2Y
writefloat s physicArray[wp].phyPos2Z
writefloat s physicArray[wp].phyRot1X
writefloat s physicArray[wp].phyRot1Y
writefloat s physicArray[wp].phyRot1Z
writefloat s physicArray[wp].phyRot2X
writefloat s physicArray[wp].phyRot2Y
writefloat s physicArray[wp].phyRot2Z
writefloat s physicArray[wp].sprPosX
writefloat s physicArray[wp].sprPosY
writefloat s physicArray[wp].sprPosZ
writefloat s physicArray[wp].sprRotX
writefloat s physicArray[wp].sprRotY
writefloat s physicArray[wp].sprRotZ
)




Print("Data Write: ("+(((timestamp())-ts)as string)+" Milli Seconds)");ts = timestamp()

-- errorLog+="hello\n"
-- errorLog+="myname is\n"

if errorLog!="" do messagebox errorLog
gc()
fclose s






)else(Print "Aborted")
if ssource !=undefined do print("Done! ("+((((timestamp())-st)/60)as string)+" Seconds)")
) -- End of Button Brace
on btn3 pressed do( --VMD Import
messagebox "Warning: \nImport Still a Work In Progress"
fsource = GetOpenFileName \
caption:"VMD / VPD Importer" \
types: "Vocaloid Motion Data(*.vmd)|*.VMD|Vocaloid Pose Data(*.vpd)|*.VPD|All files (*.*)|*.*|"
if (fsource!=undefined) AND ((doesFileExist fsource)==true) then(
f = fopen fsource "rb"
fext=           getFilenameType fsource
fpath=          getFilenamePath fsource
fbatch=         getFiles (fpath+"*"+fext)
fname=  getFilenameFile fsource
fsize=          getFileSize fsource
--===========================================================================
undo off(
with redraw off (
if fext==".pmm" do(Print "PMM, Not Supported yet")
if fext==".vmd" do(
fn ReadFixedString bstream fixedLen =
(
	local str = ""
	for i = 1 to fixedLen do
	(
		str0 = ReadByte bstream #unsigned
		if str0==0x0A do str+="\r\n"
		if str0!=0xFD AND str0!=0xFC do str+= bit.intAsChar str0
	)
	str
)

sceneBones=#()
motionArray=#()
struct VMD_MOTION (
boneName,
frameIndex,
bonePos,
boneRot
)

-- ==========================================================================
--||										Read Animations
-- ==========================================================================
frameCount=0
vmdName=readFixedString f 50

nodeCount=readlong f #unsigned
if nodeCount!=0 do(
Print ("Found Bone Animation Data @ 0x"+((bit.intAsHex(ftell f-4))as string))
obj=$*
for x = 1 to obj.count do(
if classOf obj[x] == BoneGeometry do (
append sceneBones obj[x].name))
for x = 1 to nodeCount do(
nodeName=findItem sceneBones (readFixedString f 15)
if nodeName!=0 then(
frameIndex=readlong f #unsigned+2
if frameCount<=frameIndex do frameCount=frameIndex
posX=readfloat f
posY=readfloat f
posZ=readfloat f
rotX=readfloat f
rotY=readfloat f
rotZ=readfloat f
rotW=readfloat f*-1
ukn=readfloat f
ukn=readfloat f
ukn=readfloat f
ukn=readfloat f
ukn=readfloat f
ukn=readfloat f
ukn=readfloat f
ukn=readfloat f
ukn=readfloat f
ukn=readfloat f
ukn=readfloat f
ukn=readfloat f
ukn=readfloat f
ukn=readfloat f
ukn=readfloat f
ukn=readfloat f
append motionArray (VMD_MOTION boneName:sceneBones[nodeName] frameIndex:frameIndex bonePos:[posX,posZ,posY] boneRot:(quat rotX rotZ rotY rotW))
)else(fseek f 0x60 #seek_cur)))

morCount=readlong f #unsigned
if morCount!=0 do (
Print ("Found Morph Animation Data @ 0x"+((bit.intAsHex(ftell f-4))as string))
for x = 1 to morCount do(
morName=readFixedString f 15
frameIndex=readlong f #unsigned+2
morphAmount=readfloat f -- between 0.0 - 1.0 * 100 to convert to max slider percent
))
camCount=readlong f #unsigned
if camCount!=0 do (
Print ("Found Camera Animation Data @ 0x"+((bit.intAsHex(ftell f-4))as string))
for x = 1 to camCount do(
frameIndex=readlong f #unsigned+2
targetDistance=readfloat f
posX=readfloat f
posY=readfloat f
posZ=readfloat f
rotX=readfloat f*-1
rotY=readfloat f
rotZ=readfloat f
-- (eulerAngles rotX,rotZ,rotY)
ukn=readfloat f
ukn=readfloat f
ukn=readfloat f
ukn=readfloat f
ukn=readfloat f
ukn=readfloat f
camFOV=readfloat f
orthoToggle=readbyte f --Perspective; // 0:on 1:off
))

litCount=readlong f #unsigned
if litCount!=0 do (
Print ("Found Light Animation Data @ 0x"+((bit.intAsHex(ftell f-4))as string))
for x = 1 to litCount do(
frameIndex=readlong f #unsigned+2
if frameCount<=frameIndex do frameCount=frameIndex
cRed=readfloat f
cBlu=readfloat f
cGrn=readfloat f
posX=readfloat f
posY=readfloat f
posZ=readfloat f
))
-- this part is wrong, unable to read last bit of data corrrectly, requires more research!
-- Print ("Shadowing Animation Data @ 0x"+((bit.intAsHex(ftell f))as string))
-- sdwCount=readlong f #unsigned
-- for x = 1 to sdwCount do(
-- frameIndex=readlong f #unsigned+2
-- shadowMode=readbyte f #unsigned --00-02
-- shadowDistance=readfloat f -- 0.1 - (dist * 0.00001)
-- )





-- / / / / Complement of the interpolation / / / /
--  Interpolated curve for
--  (0,0), A (ax, ay), B (bx, by), (127,127) cubic (4 points) Bezier
--  A: The lower left +, B: on the right +
--    VMD additional interpolation

--  The order of interpolated motion parameters (MMD information sheet)
--  4-axis rotation (quaternion), but are summarized in Note 1
--  X Y-axis Z-axis rotation
--  A (Xax, Xay) (Yax, Yay) (Zax, Zay) (Rax, Ray)
--  B (Xbx, Xby) (Ybx, Yby) (Zbx, Zby) (Rbx, Rby)
--  You,
--  Xax, Yax, Zax, Rax, Xay, Yay, Zay, Ray, Xbx, Ybx, Zbx, Rbx, Xby, Yby, Zby, Rby,
--  Yax, Zax, Rax, Xay, Yay, Zay, Ray, Xbx, Ybx, Zbx, Rbx, Xby, Yby, Zby, Rby, 01,
--  Zax, Rax, Xay, Yay, Zay, Ray, Xbx, Ybx, Zbx, Rbx, Xby, Yby, Zby, Rby, 01,00,
--  Rax, Xay, Yay, Zay, Ray, Xbx, Ybx, Zbx, Rbx, Xby, Yby, Zby, Rby, 01,00,00

--  Interpolation of the camera (estimated)
--  Assuming that the same order of interpolation and motion
--  X Y-axis Z-axis rotation distance visual cortex.
--  A (Xax, Xay) (Yax, Yay) (Zax, Zay) (Rax, Ray) (Lax, Lay) (VAax, VAay)
--  B (Xbx, Xby) (Ybx, Yby) (Zbx, Zby) (Rbx, Rby) (Lbx, Lby) (VAbx, VAby)
--  , The
--  Xax, Yax, Zax, Rax, Lax, VAax, Xay, Yay, Zay, Ray, Lay, VAay,
--  Xbx, Ybx, Zbx, Rbx, Lbx, VAbx, Xby, Yby, Zby, Rby, Lby, VAby



-- ==========================================================================
--||										Import Animations
-- ==========================================================================

animationRange = interval 1f frameCount

sceneBones=#()
scenePos=#()
sceneHelpers=#()
find=#()

obj=$*
for x = 1 to obj.count do if (classOf obj[x].baseobject) == BoneGeometry do append sceneBones obj[x]
for x= 1 to sceneBones.count do(
nodeHelper=Dummy pos:sceneBones[x].pos parent:sceneBones[x] boxsize: [0.5,0.5,0.5]
append scenePos [nodeHelper.pos.x,nodeHelper.pos.y,nodeHelper.pos.z]
	append sceneHelpers nodeHelper
append find sceneBones[x].name)
animate on(



for x =  1 to motionArray.count do(


obj=getnodebyname motionArray[x].boneName
nodeHelper=findItem find obj.name
if obj!=undefined AND nodeHelper!=0 do(

-- sliderTime = motionArray[x].frameIndex
at time motionArray[x].frameIndex (
newPos=scenePos[nodeHelper]+motionArray[x].bonePos
newPos=newPos-obj.pos
nodeHelper=sceneHelpers[nodeHelper]

in coordsys nodeHelper move obj newPos
	
-- rotX=(motionArray[x].boneRot.x)
-- rotY=(motionArray[x].boneRot.y)
-- rotZ=(motionArray[x].boneRot.z)
-- rotW=(motionArray[x].boneRot.w)
-- print rotX
-- print rotY
-- print rotZ
-- print rotW
-- in coordsys local rotate obj (quat rotX rotY rotZ rotW)
in coordsys nodeHelper rotate obj (inverse nodeHelper.rotation) --resets the rotation
in coordsys nodeHelper rotate obj motionArray[x].boneRot

)
	

	)



)


)
sliderTime = 1f
for x= 1 to sceneHelpers.count do(
delete sceneHelpers[x])

Print ("Last Read @ 0x"+((bit.intAsHex(ftell f))as string))
enableSceneRedraw()
flushLog()
closeLog()
gc()
fclose f
Print ("Done! ("+((((timestamp())-st)/60)as string)+" Seconds)") --print time to finish
)
if fext==".vpd" do(

fclose f
f=MemStreamMgr.openFile fsource
st = timestamp() --get start time in milliseconds
print (fname+fext+"\n"+localTime+"\n")
sceneBones=#()
find=#()
sceneHelpers=#()
poseArray=#()
struct pose(
BoneName,
BonePos,
BoneRot	
)
count=undefined
peek=f.readLine()
Print peek
f.skipSpace()
peek=f.readLine()
peek=readDelimitedString (peek as stringstream) ";"
if (peek as integer)==undefined then(
Print peek
peek=f.readLine()
peek=readDelimitedString (peek as stringstream) ";"
count=peek as integer
)else(count=(peek as integer))
if count!=undefined do(
f.skipSpace()
for x= 1 to count do(
peek=(f.readLine() as stringstream)
index=readDelimitedString peek "{"
bname=readDelimitedString peek ""
f.skipSpace()
peek=f.readLine()
peek=readDelimitedString (peek as stringstream) ";"
peek=(readDelimitedString (peek as stringstream) ";") as stringstream
posX=readDelimitedString peek "," as float
posZ=readDelimitedString peek "," as float
posY=readDelimitedString peek "" as float
f.skipSpace()
peek=f.readLine()
peek=(readDelimitedString (peek as stringstream) ";") as stringstream
rotX=readDelimitedString peek "," as float
rotZ=readDelimitedString peek "," as float
rotY=readDelimitedString peek "," as float
rotW=readDelimitedString peek "" as float
f.skipSpace()
peek=f.readLine()
peek=skipToString (peek as stringstream) "}"
f.skipSpace()
if peek==undefined then EXIT
append poseArray (pose BoneName:bname BonePos:[posX,posY,posZ] BoneRot:[(rotX*1),(rotY*1),(rotZ*1),(rotW*-1)])))
MemStreamMgr.close f
if poseArray.count!=0 do(
obj=$*
for x = 1 to obj.count do if (classOf obj[x].baseobject) == BoneGeometry do append sceneBones obj[x]
for x= 1 to sceneBones.count do(
nodeHelper=Dummy pos:sceneBones[x].pos parent:sceneBones[x] boxsize: [0.5,0.5,0.5]
append sceneHelpers nodeHelper
append find sceneBones[x].name)
for x =  1 to poseArray.count do(
obj=getnodebyname poseArray[x].BoneName
nodeHelper=findItem find obj.name
if obj!=undefined AND nodeHelper!=0 do(
nodeHelper=sceneHelpers[nodeHelper]
in coordsys nodeHelper move obj poseArray[x].BonePos
in coordsys nodeHelper rotate obj (quat poseArray[x].BoneRot.x poseArray[x].BoneRot.y poseArray[x].BoneRot.z poseArray[x].BoneRot.w)))
for x= 1 to sceneHelpers.count do(
delete sceneHelpers[x]))
gc()
fclose f
Print ("Done! ("+((((timestamp())-st)/60)as string)+" Seconds)") --print time to finish	
)
gc()
fclose f
))) else (Print "Aborted.")
)
on btn4 pressed do(

messagebox "Sorry \nThis Feature Isn't Complete Yet"

)
on bwse pressed do(
print  "Sorry \nThis Feature Isn't Complete Yet"
fsource = GetOpenFileName \
caption:"File Browser" \
types: "Text(*.txt)|*.TXT|All files (*.*)|*.*|"
)
on abtBttn pressed do(
-- messagebox "PMD Tool\nBy: Mario_Kart64n\n\nScript is still Beta\n\t\t(Mar2011)"
rollout AboutBox "Untitled" width:300 height:200
(
	label lbl3 "PMD Tool (v0.6) (March2011)" pos:[16,15] width:263 height:16
	label lbl4 "__________________________________________________________________________" pos:[18,29] width:263 height:17
	label lbl5 "- Mario_Kart64n (mario_kart64n@hotmail.com)" pos:[19,176] width:272 height:19
	label lbl8 "__________________________________________________________________________" pos:[18,153] width:263 height:17
	label lbl9 "Hello\nScript was created to help 3D artists get their models into MikuMikuDance.\n\nIf you have questions, please address them to my email below." pos:[19,55] width:262 height:87
) createDialog AboutBox 
)
on btnA pressed do( --Hide Collision Model
obj=$*
for x  = 1 to obj.count do(
if classOf obj[x]==Capsule do hide obj[x]
if classOf obj[x]==Sphere do hide obj[x]
if classOf obj[x]==Box do hide obj[x]
if classOf obj[x]==Point_Point do hide obj[x]
)
) -- End of Button Brace
on btnB pressed do( --Hide Nubs
obj=$*
for x = 1 to obj.count do(
if classOf obj[x]==BoneGeometry \
AND obj[x].children.count==0 do(
hide obj[x]))
) -- End of Button Brace
on btnC pressed do( --Flag White
obj=getCurrentSelection()
for x = 1 to obj.count do(
if classOf obj[x]==BoneGeometry do(
setUserProp obj[x] "BoneType" 7
obj[x].wirecolor = (color 211 211 211)))
if obj.count==0 do messagebox "Nothing Selected"
) -- End of Button Brace
on btnD pressed do( --UV Checker
badObj=#()
polyObj=#()
obj=getCurrentSelection()
for x = 1 to obj.count do(
if classOf obj[x]==Editable_Mesh then(
if (getNumTVerts obj[x])!=(getNumVerts obj[x]) do(
append badObj obj[x].name)
)else(
if classOf obj[x]==Editable_Poly do(append polyObj obj[x].name)))
badObjstr=""
polyObjstr=""
for x = 1 to badObj.count do(
badObjstr+=(" - "+(badObj[x] as string)+"\n"))
for x = 1 to polyObj.count do(
polyObjstr+=(" - "+(polyObj[x] as string)+"\n"))
if badObjstr!="" then(
messageBox ("UV Discontinuities Found:\n"+badObjstr)
)else(if badObj.count==0 do (messageBox "UV's are Good!"))
if polyObjstr!="" do(
messageBox ("Please Convert to EditableMesh:\n"+polyObjstr))
if obj.count==0 do messageBox "Nothing Selected"	
) -- End of Button Brace
on btnX pressed do( -- Tool Box
rollout toolbox "PMD ToolBox" width:180 height:370
(
	groupBox grpMesh "Mesh Tools" pos:[10,9] width:160 height:170
	button btnA1 "Copy/Paste Info" pos:[26,35] width:130 height:25
	button btnA2 "Collaspe Morphs" pos:[25,70] width:130 height:25 enabled:true
	button btnA3 "Reset Transform" pos:[25,105] width:130 height:25 enabled:true
	button btnA4 "-Empty-" pos:[25,140] width:130 height:25 enabled:false
	groupBox grpBones "Bone Tools" pos:[10,186] width:160 height:170
	button btnB1 "Set Bone Behavior" pos:[26,211] width:130 height:25
	button btnB2 "Collision Shape" pos:[25,246] width:130 height:25 enabled:true
	button btnB3 "Add Collision" pos:[25,281] width:130 height:25
	button btnB4 "Add Collision / IKs" pos:[25,316] width:130 height:25
	Local clipboard=""
on btnA1 pressed do( -- Copy and Paste the User Info
msh=getCurrentSelection()
if clipboard=="" AND msh.count==1 then(
clipboard=(getUserPropBuffer $)
if clipboard!="" then( Print "Copied")else(MessageBox "Error!\nNothing To Copy")
)else(if clipboard!="" then(
for x = 1 to msh.count do(
	print clipboard
setUserPropBuffer msh[x] clipboard
)
Print "Pasted"
clipboard=""
)else(MessageBox "Error!\nOnly One Object Is Allowed In Selection"))
-- DestroyDialog <Rollout>
print "f"
print clipboard
) -- End of Button Brace
on btnA2 pressed do( -- Collaspe Morphs (operation caues mismatched UVs, and not practical with using editable poly)
msh=getCurrentSelection()
activeModifiers=#()
activeMorphs=#()
zeroMorps=false
faceMorph=true -- faceMorph not implemented yet!
skinMod=undefined

if msh.count==1 then(
if classof msh[1].baseObject == Editable_Mesh then(
undo off(
with redraw off (
if zeroMorps==true do( -- Sets all Morph Weights back to Zero! (Off by Default)
for mc = 1 to msh[1].modifiers.count do(
if classOf msh[1].modifiers[mc] == Morpher do (
morMod=msh[1].modifiers[mc]
for x = 1 to 100 do WM3_MC_SetValue morMod x 0.0)))

for mc = 1 to msh[1].modifiers.count do(
if classOf msh[1].modifiers[mc] == Morpher do (
counter=0
morMod=msh[1].modifiers[mc]
append activeModifiers morMod.name
for x = 1 to 100 do(	
if (WM3_MC_NumMPts morMod x)!=0 do(
WM3_MC_SetValue morMod x 100.0
counter+=1
num="00"
if counter>=10 do num="0"
if counter>=100 do num=""
num+=(counter as string)
newMorph=copy msh[1]
newMorph.name=(num+" ["+morMod.name+"] "+(WM3_MC_GetName morMod x))
collapseStack newMorph
hide newMorph --? any speed increase
append activeMorphs newMorph
WM3_MC_SetValue morMod x 0.0)))
if classOf msh[1].modifiers[mc] == Skin do (
skinMod=msh[1].modifiers[mc]
))
newMorph=copy msh[1]
newMorph.name+=" [Collasped]"
max modify mode
uvwMod = Unwrap_UVW ()
addModifier newMorph uvwMod
subobjectLevel = 1
modPanel.setCurrentObject uvwMod
subobjectLevel = 0
collapseStack newMorph
select newMorph
for x = 1 to activeModifiers.count do(
max modify mode
morMod = Morpher ()
modPanel.setCurrentObject morMod
addModifier newMorph morMod
morMod.name=activeModifiers[(activeModifiers.count-(x-1))])
for x = 1 to activeMorphs.count do(
morName=activeMorphs[x]
morName=morName.name as stringstream
num=(readChars morName 3) as integer
morCate=skipToString morName "["
morCate=readDelimitedString morName "]"
readChar morName
morName=readLine morName
selMorMod=newMorph.modifiers[morCate]
WM3_MC_BuildFromNode selMorMod num activeMorphs[x]
WM3_MC_SetName selMorMod num morName
delete activeMorphs[x])
clearSelection()
update newMorph
select newMorph
if skinMod!=undefined do( -- Vertex Weights Seem Bad After Adding Back
max modify mode
select newMorph
addModifier newMorph skinMod)
gc()
enableSceneRedraw()
Print "Morph Collapse Complete!"
)))else(MessageBox "Error! Bad Selection\nCheck That Selection is Editable Mesh")
)else(MessageBox "Nothing Selected?")
) -- End of Button Brace
on btnA3 pressed do(messagebox "Sorry \nThis Feature Isn't Complete Yet") -- End of Button Brace
on btnA4 pressed do(messagebox "Sorry \nThis Feature Isn't Complete Yet") -- End of Button Brace
on btnJ pressed do( -- !NotEnabled In GUI ! -Shrinks Bones By 10%-
obj=getCurrentSelection()
for x = 1 to obj.count do(
if classOf obj[x]==BoneGeometry do(
obj[x].width = obj[x].width*0.80
obj[x].height =obj[x].height*0.80
))) -- End of Button Brace
on btnB1 pressed do(
messageBox "UnderConstruction"
rollout BoneBehavior "Untitled" width:310 height:358
(
	label lbl10 ">  First Select A Bone" pos:[12,10] width:247 height:17
	label lbl11 ">  Next Select One of the MMD Bone Behaviors" pos:[11,32] width:290 height:17
	colorPicker cp3 "" pos:[24,50] width:20 height:20 color:(color 145 200 255)
	button btn25 "Rotate Only (Normal Bone)" pos:[53,48] width:242 height:24
	label lbl12 "1" pos:[9,52] width:13 height:17
	colorPicker cp4 "" pos:[24,80] width:20 height:20 color:(color 180 255 140)
	button btn26 "Rotate & Move (Root/Center Bone Only)" pos:[53,78] width:242 height:24
	label lbl13 "2" pos:[9,82] width:13 height:17
	colorPicker cp5 "" pos:[24,110] width:20 height:20 color:(color 255 97 0)
	button btn27 "IK Controller (Start of IK Chain)" pos:[53,108] width:242 height:24
	label lbl14 "3" pos:[9,112] width:13 height:17
	colorPicker cp6 "" pos:[24,140] width:20 height:20 color:(color 0 0 0)
	button btn28 "Disable Bone" pos:[53,138] width:242 height:24
	label lbl15 "4" pos:[9,142] width:13 height:17
	colorPicker cp7 "" pos:[24,170] width:20 height:20 color:(color 255 212 127)
	button btn29 "IK Limb (Rotate Only)" pos:[53,168] width:242 height:24
	label lbl16 "5" pos:[9,172] width:13 height:17
	colorPicker cp8 "" pos:[24,200] width:20 height:20 color:(color 50 105 255)
	button btn30 "LookAt Constraint (Eye Controller)" pos:[53,198] width:242 height:24
	label lbl17 "6" pos:[9,202] width:13 height:17
	colorPicker cp9 "" pos:[24,230] width:20 height:20 color:(color 255 147 156)
	button btn31 "IK End Point (End of IK Chain)" pos:[53,228] width:242 height:24
	label lbl18 "7" pos:[9,232] width:13 height:17
	colorPicker cp10 "" pos:[24,260] width:20 height:20 color:(color 211 211 211)
	button btn32 "Endpoint (Bone Hidden)" pos:[53,258] width:242 height:24
	label lbl19 "8" pos:[9,262] width:13 height:17
	colorPicker cp11 "" pos:[24,290] width:20 height:20 color:(color 186 84 255)
	button btn33 "?? Twist Bone ??" pos:[53,288] width:242 height:24
	label lbl20 "9" pos:[9,292] width:13 height:17
	colorPicker cp12 "" pos:[24,320] width:20 height:20 color:(color 174 165 255)
	button btn34 "?? Integration Revolution ??" pos:[53,318] width:242 height:24
	label lbl21 "10" pos:[5,322] width:13 height:17
	



) createDialog BoneBehavior
) -- End of Button Brace
on btnB2 pressed do(messagebox "Sorry \nThis Feature Isn't Complete Yet") -- End of Button Brace
on btnB3 pressed do(messagebox "Sorry \nThis Feature Isn't Complete Yet") -- End of Button Brace
on btnB4 pressed do( --Auto Link Bones
obj=getCurrentSelection()
boneArray=#()
rootArray=#()
endArray=#()
shapeArray=#()

if obj.count>=2 then(
for x=1 to obj.count do(
if classOf obj[x]==BoneGeometry do(
if (findItem obj obj[x].parent)==0 \
AND obj[x].children.count!=0 do(
if classOf obj[x].transform.controller!= \
IKControl do append rootArray obj[x])
if obj[x].children.count!=0 then(
childs=0
for y = 1 to obj[x].children.count do(
childs+=(findItem obj obj[x].children[y]))
if childs==0 and obj[x].parent!=undefined do(
append endArray obj[x]	
))else(if obj[x].parent!=undefined do append endArray obj[x])))
if rootArray.count!=0 AND endArray.count!=0 then(
for x = 1 to endArray.count do(
-- boneArray=#()
rootBone=endArray[x]
endBone=endArray[x]
while (findItem rootArray rootBone)==0 \
AND rootBone.parent!=undefined do(
if keyboard.escPressed then exit
rootBone=rootBone.parent)
append boneArray rootBone
rootBone=rootBone
ikchain=IKSys.ikChain rootBone endBone "IKHISolver"
ikchain.transform.controller.goalSize = 10
))else (if obj.count>=2 do(
messageBox "Error!:\nIKController already in use"))

if rootArray.count!=0 do(
for x = 1 to obj.count do(
phyPresent=false
for y = 1 to obj[x].children.count do(
if (classOf obj[x].children[y].baseobject) == Capsule \
or (classOf obj[x].children[y].baseobject) == Sphere \
or (classOf obj[x].children[y].baseobject) == Box \
do (phyPresent=true)
)
if phyPresent==false AND obj[x].children.count!=0 do(
pShape=Capsule radius:(obj[x].length*obj[x].scale.x*0.15) \
pivot:[0,0,((obj[x].length*obj[x].scale.x*0.75)/2)] \
pos:obj[x].center \
height:(obj[x].length*obj[x].scale.x*0.75) \
heighttype:0 sides:8 heightsegs:1 \
smooth:on sliceon:off \
sliceFrom:0 sliceTo:0 \
wirecolor:(color 255 200 150) \
mapcoords:on realWorldMapSize:on \
isSelected:on
rotate pShape (angleaxis 90 [0,1,0])
rotate pShape obj[x].rotation
pShape.parent=obj[x]
setUserProp pShape "Type" 1
append shapeArray pShape
))
for x = 1 to shapeArray.count do(
if (findItem rootArray shapeArray[x].parent)!=0 do(
setUserProp shapeArray[x] "Type" 0)))
if shapeArray.count>=1 do(
for x = 1 to shapeArray.count do(
if shapeArray[x].parent.parent!=undefined do(
for y = 1 to shapeArray[x].parent.parent.children.count do(
if classOf (shapeArray[x].parent.parent.children[y]) == Capsule do (
max modify mode
obj=Point_Point ()
modPanel.setCurrentObject obj
obj.iconSize = 0.1
obj.childBody = shapeArray[x]
obj.parentBody = shapeArray[x].parent.parent.children[y]
obj.hasParent = on
obj.alignToParentBody()
obj.childTransform =transmatrix[0,0,0]
obj.lockSpaces = on
))))))else(if obj.count==0 then (messageBox "Error!:\nNothing Selected?")
else(MessageBox "Error!:\nOnly One Bone in Selection"))
print "DONE"
) -- End of Button Brace

) createDialog toolbox
	) -- End of Button Brace


) createDialog unnamedRollout
gc()
-- clearlistener()